package uchicago.src.nqpy.builtin;

import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.List;

/**
 * Java version of the Python range builtin function.
 * 
 * $Revision: 1.2 $ $Date: 2004/10/12 13:18:21 $
 */
public class range {
  
  private List list = new ArrayList();
  
  private range() {}
  
  public range(int stop) {
    this(0, stop, 1);
  }
  
  public range(int start, int stop) {
    this(start, stop, 1);
    
  }
  
  public range(int start, int stop, int step) {
    if (stop > 0) {
      int val = start;
      int index = 0;
      while (val < stop) {
        list.add(new Integer(val));
        index++;
        if (index < 1) val = start + step;
        else val = start + index * step;
      }
    } else if (stop < 0 && step < 0) {
      int val = start;
      int index = 0;
      while (val > stop) {
        list.add(new Integer(val));
        index++;
        if (index < 1) val = start + step;
        else val = start + index * step;
      } 
    }
  }
  
  public String toString() {
    return list.toString();
  }

  public int size() {
    return list.size();
  }

  public void clear() {
    list.clear();
  }

  public boolean isEmpty() {
    return list.isEmpty();
  }

  public Iterator iterator() {
    return list.iterator();
  }
  
  public range subrange(int start, int end) {
    range temp = new range();
    if (start < 0) {
      start = list.size() + start;
    }
    
    if (end < 0) {
      end = list.size() + end;
    }
    
    if (start <= end) temp.list = list.subList(start, end);
    return temp;
  }

  public int get(int index) {
    if (index < 0) {
      return ((Integer)list.get(list.size() + index)).intValue();
    }
    return ((Integer)list.get(index)).intValue();
  }
  
  public void set(int index, int val) {
    if (index < 0) index = list.size() + index;
    list.set(index, new Integer(val));
  }
}
