package uchicago.src.nqpy.compiler;

import uchicago.src.nqpy.parser.*;

/**
 * Handles the built-in function class("...") where "..." is the name of
 * a class.
 */
public class ClassBuiltInFunc extends AbstractBuiltInFunc {

  private SimpleNode arg;
  private NQPyClass javaClass;
  
  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler, ASTarglist args) {
    argSizeCheck("class", args, 1);
    SimpleNode arg = (SimpleNode)args.jjtGetChild(0);
    if (! (arg instanceof ASTString)) {
      String message = "Built-in function jclass(...) must take a String " +
	"literal as an argument";
      throw ErrorFactory.createCompilerException(message);
    }
    
    String className = arg.getInfo().toString();
    javaClass = NQPyClassFactory.makeJavaClass(className);
    if (javaClass == null) {
      String message = "Java Class '" + className + "' not found";
      throw ErrorFactory.createCompilerException(message);
    }
    
    return NQPyClassFactory.makeNQPyClass(Class.class);
    
  }
  
  public void compile(NQPyBlockCompiler compiler) {
    compiler.emitClassLookup(javaClass);
  }
}
