package uchicago.src.nqpy.compiler;

import com.go.trove.classfile.*;

public class CompilerUtil {

  public static TypeDescriptor[] makeTypeDescriptors(String[] classNames) {
    if (classNames == null) return new TypeDescriptor[0];
    TypeDescriptor[] tds = new TypeDescriptor[classNames.length];
    for (int i = 0; i < classNames.length; i++) {
      tds[i] = new TypeDescriptor(classNames[i]);
    }

    return tds;
  }

  public static TypeDescriptor[] makeTypeDescriptors(Class[] classes) {
    if (classes == null) return new TypeDescriptor[0];
    TypeDescriptor[] tds = new TypeDescriptor[classes.length];
    for (int i = 0; i < classes.length; i++) {
      tds[i] = new TypeDescriptor(classes[i]);
    }

    return tds;
  }

  public static TypeDescriptor[] makeTypeDescriptors(NQPyClass[] classes) {
    if (classes == null) return new TypeDescriptor[0];
    TypeDescriptor[] tds = new TypeDescriptor[classes.length];
    for (int i = 0; i < classes.length; i++) {
      tds[i] = classes[i].makeTypeDescriptor();
    }

    return tds;
  }

  public static TypeDescriptor[] makeTypeDescriptors(NQPyClass nqclass) {
    if (nqclass == null) return new TypeDescriptor[0];
    TypeDescriptor[] tds = new TypeDescriptor[1];
    tds[0] = nqclass.makeTypeDescriptor();
    return tds;
  }

  public static TypeDescriptor[] makeTypeDescriptors(Class c) {
    if (c == null) return new TypeDescriptor[0];
    TypeDescriptor[] tds = new TypeDescriptor[1];
    tds[0] = new TypeDescriptor(c);
    return tds;
  }
}
