package uchicago.src.nqpy.compiler;

import java.lang.reflect.Modifier;

public class FieldCall {

  private String className;
  private String fieldName;
  private NQPyClass fieldType;
  private int mods;
  
  public FieldCall(String className, String fieldName, NQPyClass fieldType,
		   int mods) {
    this.className = className;
    this.fieldName = fieldName;
    this.fieldType = fieldType;
    this.mods = mods;
  }

  public String getDeclaringClassName() {
    return className;
  }

  public String getFieldName() {
    return fieldName;
  }

  public NQPyClass getFieldType() {
    return fieldType;
  }

  public boolean isStatic() {
    return Modifier.isStatic(mods);
  }

  public boolean isPublic() {
    return Modifier.isPublic(mods);
  }

  public boolean isProtected() {
    return Modifier.isProtected(mods);
  }
  
  public boolean isPrivate() {
    return Modifier.isPrivate(mods);
  }
}
