package uchicago.src.nqpy.compiler;

import uchicago.src.nqpy.parser.SimpleNode;
import com.go.trove.classfile.Label;

public class JavaEmitter extends AbstractEmitter {
  
  public JavaEmitter(NQPyClass nqclass) {
    super(nqclass);
  }
  
  /**
   * Emits the appropriatxe byte code to go to the specified branch
   * if the specified node compiles to true. This tests whether
   * the result of node.compile() is null, and branches if not so.
   */
  public void branchOnTrue(SimpleNode node, NQPyBlockCompiler compiler,
		   Label branch)
  {
    node.compile(compiler);
    compiler.emitIfNotNull(branch);
  }

  /**
   * Emits the appropriate byte code to go to the specified branch
   * if the single node in nodes compiles to false. This tests whether
   * the result of node.compile() is null, and branches if so.
   */
  public void branchOnFalse(SimpleNode node, NQPyBlockCompiler compiler,
		   Label branch)
  {
    node.compile(compiler);
    compiler.emitIfNull(branch);
  }


  public void eqCmpJava(SimpleNode lhsn, SimpleNode rhsn, Label branch,
		       NQPyBlockCompiler compiler)
  {
    lhsn.compile(compiler);
    rhsn.compile(compiler);
    compiler.emitInvokeVirtual("java.lang.Object", "equals",
			       boolean.class, new Class[] {Object.class});
    compiler.emitNotEqZero(branch);
  }
}
