package uchicago.src.nqpy.compiler;

import cern.colt.map.OpenIntObjectHashMap;

import java.lang.reflect.Modifier;

public class MethodCall {

  OpenIntObjectHashMap argConversions = new OpenIntObjectHashMap();
  Class retType;
  String strRetType;
  protected boolean isValid = true;
  protected NQPyClass declaringClass;
  protected NQPyClass[] args;
  private String methodName;
  private int mods = 0;

  /*
  public static class IntNQPy {
    public int argIndex = -1;
    public NQPyClass convertTo;

    public IntNQPy(int argIndex, NQPyClass convertTo) {
      this.argIndex = argIndex;
      this.convertTo = convertTo;
    }
  }
  */
  
  public MethodCall() {}

  public boolean isStatic() {
    return Modifier.isStatic(mods);
  }

  public boolean isPublic() {
    return Modifier.isPublic(mods);
  }

  public boolean isProtected() {
    return Modifier.isProtected(mods);
  }

  public void setModifiers(int mods) {
    this.mods = mods;
  }

  public void setRetType(Class ret) {
    retType = ret;
  }

  public void setRetType(String retType) {
    strRetType = retType;
  }

  public NQPyClass getRetType() {
    if (retType == null) return NQPyClassFactory.makeNQPyClass(strRetType);
    return NQPyClassFactory.makeNQPyClass(retType);
  }

  public NQPyClass getDeclaringClass() {
    return declaringClass;
  }

  public void setDeclaringClass(NQPyClass nqc) {
    declaringClass = nqc;
  }

  public String getMethodName() {
    return methodName;
  }
  
  public void setMethodName(String val){
    methodName = val;
  }

  public NQPyClass[] getArgs() {
    return args;
  }

  public void setArgs(NQPyClass[] argz) {
    args = argz;
  }

  public boolean isValid() {
    return isValid;
  }

  public void setValid(boolean val) {
    isValid = val;
  } 

  public void addArgConversion(int index, NQPyClass convertTo) {
    argConversions.put(index, convertTo);
  }

  public NQPyClass coerceTo(int index) {
    return (NQPyClass)argConversions.get(index);
  }

  public int size() {
    return argConversions.size();
  }

  public String toString() {
    StringBuffer b;
    if (retType == null) b = new StringBuffer("NULL RetType !!!");
    else b = new StringBuffer(retType.getName());
    b.append(" ");
    b.append(methodName);
    b.append("(");
    if (args != null) {
      for (int i = 0; i < args.length; i++) {
	if (i != 0) b.append(", ");
	b.append(args[i].getJClassName());
      }
    }

    b.append(")");

    return b.toString();

  }
}
