package uchicago.src.nqpy.compiler;

//import uchicago.src.nqpy.parser.SimpleNode;

public class NQPyDoubleClass extends NQPyNumberClass {
  public NQPyDoubleClass() {
    jclass = double.class;
    jclassName = jclass.getName();
    id = DOUBLE_CLASS;
  }

  /**
   * Returns true if this NQPyDoubleClass can be coerced to the specified
   * NQPyClass.
   */
  public boolean isCoercePossible(NQPyClass toCoerce) {
    return toCoerce.id() == BOOLEAN_CLASS;
  }

  /**
   * Emit the byte code to coerce this NQPyClass to the
   * specifed NQPyClass. This will coerce a double to a boolean. Assumes the
   * int is on the stack already.
   */
  public void coerce(NQPyBlockCompiler compiler, NQPyClass toCoerce) {
    if (toCoerce.id() == BOOLEAN_CLASS) compiler.emitDoubleToBoolean();
    else {
      String message = "Unable to coerce " + this + " to " + toCoerce;
      throw ErrorFactory.createCompilerException(message);
    }
  }

  /**
   * Gets the Emitter appropriate for this NQPyIntClass.
   */
  public Emitter getEmitter() {
    return new DoubleEmitter(this);
  }

}
