package uchicago.src.nqpy.compiler;

public abstract class NQPyNumberClass extends AbstractNQPyClass {

  public NQPyNumberClass() {
    canBeBool = true;
  }

  /**
   * Performs a match of this NQPyClass to the specified NQPyClass. If there
   * is an exact match then this returns this NQPyClass. If there
   * is a match, but requires conversion of the java primitive or class
   * represented by this NQPyClass then the passed in NQPyClass is returned.
   * If there is no match at all, then null is returned.<p>
   *
   * This indicates that numbers can convert to booleans.
   */
  public NQPyClass match(NQPyClass nqclass) {
    if (inObjHeirarchy(nqclass)) return this;
    if (nqclass.id() == BOOLEAN_CLASS) return nqclass;
    return null;
  }
}
