package uchicago.src.nqpy.compiler;

//import uchicago.src.nqpy.parser.SimpleNode;

public class NQPyStringClass extends NQPyJavaClass {

  public NQPyStringClass() {
    super(String.class);
    id = STRING_CLASS;
    canBeBool = true;
  }

  /**
   * Emits byte code to coerce the java String represented by this
   * NQPyClass to a boolean primitive. An empty String is considered
   * false, anything else is true.
   */
  public void toBoolean(NQPyBlockCompiler compiler) {
    compiler.emitInvokeVirtual("java.lang.String", "length", int.class,
			       new Class[]{});
    compiler.emitIntToBoolean();
  }

  /**
   * Gets the Emitter appropriate for this NQPyIntClass.
   */
  public Emitter getEmitter() {
    return new StringEmitter(this);
  }
  
}
