package uchicago.src.nqpy.compiler;

import uchicago.src.nqpy.parser.SimpleNode;
import com.go.trove.classfile.TypeDescriptor;

public class NQPyVoid extends AbstractNQPyClass {

  public NQPyVoid() {
    id = VOID_CLASS;
  }

  public void setNode(SimpleNode node) {
    throw new UnsupportedOperationException("Cannot set node on void class");
  }

  /**
   * Returns a String representation of the Node associated with this
   * NQPyClass
   */
  public String toJString() {
    return "void";
  }

  /**
   * Returns the Java class associated with this NQPyClass. This may sometimes
   * be null.
   */
  public Class getJClass() {
    return void.class;
  }

  /**
   * Returns the name of the Java class associated with this NQPyClass.
   * This should never be null.
   */
  public String getJClassName() {
    return void.class.getName();
  }

  /**
   * Makes a TypeDescriptor for the java primitive or class that this
   * NQPyClass represents.
   */
  public TypeDescriptor makeTypeDescriptor() {
    return new TypeDescriptor(void.class);
  }

  /**
   * Returns whether the java primitive or class represented by this
   * NQPyClass is assignable from that of the specified NQPyClass.
   */
  public boolean isAssignableFrom(NQPyClass clazz) {
    return false;
  }
}
