package uchicago.src.nqpy.compiler;

public class ParserException extends AbstractCompilerException {
  
  private String[] expected;
  private int col;

  public ParserException(String line, int lineNum, int col, String[] expected,
			 String blockName)
  {
    this.line = line;
    this.lineNum = lineNum;
    this.col = col;
    this.expected = expected;
    this.blockName = blockName;

  }

  public String getMessage() {
    StringBuffer b = new StringBuffer("Block: ");
    b.append(blockName);
    b.append(", line: ");
    b.append(lineNum);
    b.append("\nSyntax Error:\n  ");
    b.append(line);
    b.append("\n  ");
    for (int i = 0; i < col; i++) {
      b.append(" ");
    }
    b.append("^");
    
    return b.toString();
  }

  public String[] getExpected() {
    return expected;
  }
}
