package uchicago.src.nqpy.compiler;

import uchicago.src.nqpy.parser.*;

/**
 * Handles the built-in function str(x) where x is some object. This
 * function returns the string representation of an object.
 */
public class StrBuiltInFunc extends AbstractBuiltInFunc {

  private NQPyClass arg;
  private NQPyClass retType;
  private ASTarglist args;

  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler, ASTarglist args) {
    argSizeCheck("str", args, 1);
    arg = args.getArgTypes(compiler)[0];
    this.args = args;
    retType = NQPyClassFactory.makeStringClass();
    return retType;
  }

  public void compile(NQPyBlockCompiler compiler) {
    args.jjtGetChild(0).compile(compiler);
    // do conversion depending on type
    Class clazz = Object.class;
    switch (arg.id()) {
      case NQPyClass.LONG_CLASS:
        clazz = long.class;
        break;

      case NQPyClass.DOUBLE_CLASS:
        clazz = double.class;
        break;

      case NQPyClass.FLOAT_CLASS:
        clazz = float.class;
        break;
      case NQPyClass.INT_CLASS:
        clazz = int.class;
        break;

      case NQPyClass.BOOLEAN_CLASS:
        clazz = boolean.class;
        break;

      default:
        break;
    }

    compiler.emitInvokeStatic("java.lang.String", "valueOf",
				retType, new Class[]{clazz});
  }
}
