/* Generated By:JJTree: Do not edit this line. ASTDot_Op.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.*;
import uchicago.src.nqpy.util.NQPyUtil;

public class ASTDot_Op extends SimpleNode {

  private MethodCall call;
  private FieldCall fcall;
  private NQPyClass[] nqargs;
  private ASTarglist arglist;
  private boolean isAssignment = false;
  private NQPyClass rhsAssignClass;
  private boolean isPropertyGet = false;
  private boolean isParentCall = false;

  public ASTDot_Op(int id) {
    super(id);
  }

  public ASTDot_Op(NQPyParser p, int id) {
    super(p, id);
  }

  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    boolean isStatic = false;
    SimpleNode lhs = (SimpleNode) children[0];
    NQPyClass lhsType = lhs.getNQPyClass(compiler);
    if (lhsType == NQPyBlockCompiler.NULL_NQPyClass) {
      // not a varible check to see if static
      lhsType = NQPyClassFactory.makeNQPyClass(lhs.info.toString());
      if (lhsType == null) {
        ErrorFactory.setCurNode(this);
        String message = "Undefined local variable '" +
                ((SimpleNode) children[0]).info.toString()
                + "'";
        throw ErrorFactory.createCompilerException(message);
      }

      isStatic = true;
    }

    String fieldName = ((SimpleNode) children[1]).info.toString();
    //System.out.println("fieldName = " + fieldName);
    //System.out.println("compiler.getClassName() = " + compiler.getClassName());

    fcall = lhsType.getFieldCall(fieldName, compiler.getClassName());
    if (fcall == null) {
      // treat name as a property and see if we can find accessor
      String capName = NQPyUtil.capitalize(fieldName);
      if (isAssignment) {
        // look for set method
        call = lhsType.getMethodCall("set" + capName, new NQPyClass[]{rhsAssignClass});
      } else {
        // look for get/is method
        call = lhsType.getMethodCall("get" + capName, new NQPyClass[]{});
        if (!call.isValid()) {
          // try with "is"
          call = lhsType.getMethodCall("is" + capName, new NQPyClass[]{});
        }
        isPropertyGet = true;
      }
    }

    if (isStatic)
      return staticFieldCall(lhsType, fieldName);
    else
      return fieldCall(lhsType, fieldName);
  }

  private NQPyClass fieldCall(NQPyClass lhsType, String fieldName) {
    if (fcall != null) {
      return fcall.getFieldType();
    }
    
    // call may not be null if field is a property name
    if (call.isValid()) {
      return call.getRetType();
    } else if (call.getMethodName() != null) {
      // if here then setPropertyName method was found, but parameter type is
      // incorrect.
      ErrorFactory.setCurNode(this);
      String message = "Invalid assignment; " + fieldName +
              " is not assignable from " + rhsAssignClass.getJClassName();
      throw ErrorFactory.createCompilerException(message);

    }

    ErrorFactory.setCurNode(this);
    String message = "Field '" + fieldName + "' is not accessible or not found in " +
            lhsType.getJClassName();
    throw ErrorFactory.createCompilerException(message);
  }

  private NQPyClass staticFieldCall(NQPyClass lhsType, String fieldName) {
    if (fcall != null) {
      if (fcall.isStatic()) {
        return fcall.getFieldType();
      }
    }

    ErrorFactory.setCurNode(this);
    String message = "Static field '" + fieldName + "' not found in " +
            lhsType.getJClassName();
    throw ErrorFactory.createCompilerException(message);
  }

  // args may be null
  public MethodCall getMethodCall(NQPyBlockCompiler compiler, ASTarglist args) {

    nqargs = new NQPyClass[0];
    if (args != null) {
      nqargs = args.getArgTypes(compiler);
      arglist = args;
    }

    boolean isStatic = false;
    SimpleNode lhs = (SimpleNode) children[0];

    // checks for method call on local var.
    NQPyClass lhsType = lhs.getNQPyClass(compiler);
    if (lhsType == NQPyBlockCompiler.NULL_NQPyClass) {
      // its not a local variable, see if a java class can be found with
      // a static method of this type.
      lhsType = NQPyClassFactory.makeNQPyClass(lhs.info.toString());
      if (lhsType == null) {
        ErrorFactory.setCurNode(this);
        String message = "Undefined local variable '" + lhs.info.toString()
                + "'";
        throw ErrorFactory.createCompilerException(message);
      }

      // if reach here then found java class of right name,
      // but no method. Is the lhs side the name of this caller's
      // parent class, if so then see if the method is a parent class
      // method, equivalent to doing Java's super.X()
      NQPyDynamicClass enclosingClass = NQPyClassFactory.getDynamicType(compiler.getClassName());
      if (lhsType.isAssignableFrom(enclosingClass)) {
        MethodCall call = parentCall(lhsType, args);
        if (call != null) isParentCall = true;
        return call;
      }
     
      // As a last resort try the static call.
      isStatic = true;
    }

    if (isStatic) return staticCall(lhsType, args);
    return methodCall(lhsType, args);
  }

  private MethodCall parentCall(NQPyClass lhsType, ASTarglist args) {
    String methName = ((SimpleNode) children[1]).info.toString();
    call = lhsType.getMethodCall(methName, nqargs);

    if (call.isValid()) return call;
    return null;
  }

  private MethodCall staticCall(NQPyClass lhsType, ASTarglist args) {

    String methName = ((SimpleNode) children[1]).info.toString();
    call = lhsType.getMethodCall(methName, nqargs);

    if (call.isValid() && call.isStatic())
      return call;
    else {
      ErrorFactory.setCurNode(this);
      String message = "Static method " + methName;
      if (args == null)
        message += "() not found in ";
      else
        message += "(" + args.toTypeString() + ") not found in ";
      message += lhsType.getJClassName();
      throw ErrorFactory.createCompilerException(message);
    }
  }

  private MethodCall methodCall(NQPyClass lhsType, ASTarglist args) {
    //System.out.println("lhsType: " + lhsType.getJClassName());
    String methName = ((SimpleNode) children[1]).info.toString();
    call = lhsType.getMethodCall(methName, nqargs);
    //System.out.println("Dot_Op mc: " + call);

    if (call.isValid())
      return call;
    else {
      ErrorFactory.setCurNode(this);
      String message = "Method " + methName;
      if (args == null)
        message += "() not found in ";
      else
        message += "(" + args.toTypeString() + ") not found in ";
      message += lhsType.getJClassName();
      throw ErrorFactory.createCompilerException(message);
    }
  }

  public void compileCall(NQPyBlockCompiler compiler) {
    if (isParentCall) {
      compiler.emitLoadLocalVar("self");
      compiler.emitInvokeSuper(call);
    } else {
      if (!call.isStatic()) children[0].compile(compiler);
      // compile the args.
      if (arglist != null) arglist.compile(compiler, call);
      compiler.emitInvokeMethod(call);
    }
  }

  public void compile(NQPyBlockCompiler compiler) {
    //System.out.println(children[0]);
    //System.out.println(children[1]);
    if (call != null && call.isValid()) {
      // call will not be null if field name was a property
      children[0].compile(compiler);
      compiler.emitInvokeMethod(call);
    } else {
      if (!fcall.isStatic()) children[0].compile(compiler);
      compiler.emitLoadField(fcall);
    }
  }

  /*
   * Called when a dot.op is the lhs side of an assignment. The
   * rhs side is the passed in SimpleNode.
   */
  public void assign(NQPyBlockCompiler compiler, SimpleNode rhs) {
    isAssignment = true;
    ErrorFactory.setCurNode(this);
    rhsAssignClass = rhs.getNQPyClass(compiler);
    NQPyClass nqclass = getNQPyClass(compiler);
    // call may be the get/set property translation, if its invalid then

    // we have straight assignment between two variable
    if ((call != null && !call.isValid()) || isPropertyGet) {
      if (!nqclass.isAssignableFrom(rhsAssignClass)) {
        String message = "Invalid assignment; " + nqclass.getJClassName() +
                " is not assignable from " + rhsAssignClass.getJClassName();
        throw ErrorFactory.createCompilerException(message);
      }
    }


    if (call == null && !nqclass.isAssignableFrom(rhsAssignClass)) {
      String message = "Invalid assignment; " + nqclass.getJClassName() +
              " is not assignable from " + rhsAssignClass.getJClassName();
      throw ErrorFactory.createCompilerException(message);
    }

    if (call != null && call.isValid()) {
      children[0].compile(compiler);
      rhs.compile(compiler);
      compiler.emitInvokeMethod(call);
    } else {
      if (!fcall.isStatic()) children[0].compile(compiler);
      rhs.compile(compiler);
      compiler.emitStoreField(fcall);
    }
  }
}
