/* Generated By:JJTree: Do not edit this line. ASTIndex_Op.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.ErrorFactory;
import uchicago.src.nqpy.compiler.NQPyBlockCompiler;
import uchicago.src.nqpy.compiler.NQPyClass;
import uchicago.src.nqpy.compiler.NQPyClassFactory;

import java.util.List;

public class ASTIndex_Op extends SimpleNode {

  private Indexer indexer;
  private boolean isIntIndex = true;

  public ASTIndex_Op(int id) {
    super(id);
  }

  public ASTIndex_Op(NQPyParser p, int id) {
    super(p, id);
  }


  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    NQPyClass nqpyClass = children[0].getNQPyClass(compiler);
    indexer = createIndexer(nqpyClass);
    if (indexer == null) return super.getNQPyClass(compiler);
    
    // two types of index ops: int index where child[1] is a int,
    // slice index where child[1] is a slice.
    int id = ((SimpleNode) children[1]).id;
    if (id == NQPyParserTreeConstants.JJTSLICE) {
      isIntIndex = false;
      return getNQPyClassForSliceType(compiler);
    } else if (id == NQPyParserTreeConstants.JJTTUPLE) {
      ErrorFactory.setCurNode(this);
      String message = "Tuple indices are not supported";
      throw ErrorFactory.createCompilerException(message);
    } else {
      NQPyClass indexNQPyClass = children[1].getNQPyClass(compiler);
      if (indexNQPyClass.id() == NQPyClass.INT_CLASS) {
        return getNQPyClassForIntType(compiler);
      }
    }

    return super.getNQPyClass(compiler);
  }

  public void compile(NQPyBlockCompiler compiler) {
    if (isIntIndex)
      indexer.compileIntIndex(compiler, (SimpleNode) children[0], (SimpleNode) children[1]);
    else
      indexer.compileSliceIndex(compiler, (SimpleNode) children[0], (ASTSlice) children[1]);
  }

  private Indexer createIndexer(NQPyClass nqpyClass) {
    ErrorFactory.setCurNode(this);
    String jClassName = nqpyClass.getJClassName();
    Indexer indexer;
    if (jClassName == null) {
      String message = "Undefined local variable '" + ((SimpleNode) children[0]).getInfo().toString() + "'";
      throw ErrorFactory.createCompilerException(message);
    }

    if (jClassName.equals("uchicago.src.nqpy.builtin.range")) {
      indexer = new RangeIndexer();
    } else if (jClassName.equals("java.lang.String")) {
      indexer = new StringIndexer();
    } else if (nqpyClass.inObjHeirarchy(NQPyClassFactory.makeNQPyClass(List.class))) {
      indexer = new ListIndexer();
    } else {
      String message = "Unsubscriptable object; object must be a String, range, or implement java.util.List";
      throw ErrorFactory.createCompilerException(message);
    }

    return indexer;
  }

  private NQPyClass getNQPyClassForIntType(NQPyBlockCompiler compiler) {
    return indexer.getNQPyClass(compiler);
  }

  private NQPyClass getNQPyClassForSliceType(NQPyBlockCompiler compiler) {
    return indexer.getNQPyClassForSlice(compiler);
  }

  public void assign(NQPyBlockCompiler compiler, SimpleNode rhs) {
    NQPyClass nqpyClass = children[0].getNQPyClass(compiler);
    indexer = createIndexer(nqpyClass);
    
    // two types of index ops: int index where child[1] is a int,
    // slice index where child[1] is a slice.
    NQPyClass indexNQPyClass = children[1].getNQPyClass(compiler);
    if (indexNQPyClass.id() == NQPyClass.INT_CLASS) {
      indexer.assign(compiler, (SimpleNode) children[0], (SimpleNode) children[1], rhs);
    } else {
      ErrorFactory.setCurNode(this);
      String message = "Item assignment using a slice is not supported";
      throw ErrorFactory.createCompilerException(message);
    }
  }
}
