/* Generated By:JJTree: Do not edit this line. ASTName.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.*;

public class ASTName extends SimpleNode {

  NQPyClass type;

  public ASTName(int id) {
    super(id);
  }

  public ASTName(NQPyParser p, int id) {
    super(p, id);
  }

  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    String val = info.toString();

    if (val.equals("false") || val.equals("true")) {
      type = NQPyClassFactory.makeBooleanClass();
      // implement None keywords
    } else if (val.equals("None")) {
      type = NQPyClassFactory.makeNQPyClass(Object.class);
    } else {
      type = compiler.getNQPyClassForVar(val);
    }

    // if the var is not found this will return NQPyBlockCompiler.NULL_NQPyClass;
    // client code should check for this and return the appropriate error
    // message
    return type;
  }

  // args may be null
  public MethodCall getConstructorCall(NQPyBlockCompiler compiler,
				      ASTarglist args)
  {
    // must be a java constructor call
    NQPyClass[] nqargs = new NQPyClass[0];
    if (args != null) nqargs = args.getArgTypes(compiler);
    NQPyClass nqclass = NQPyClassFactory.makeJavaClass(info.toString());
    if (nqclass == null) {
      ErrorFactory.setCurNode(this);
      String message = "Java class " + info.toString() + " not found";
      throw ErrorFactory.createCompilerException(message);
    }

    MethodCall call = nqclass.getConstructorCall(nqargs);
    if (call.isValid()) return call;
    else {
      ErrorFactory.setCurNode(this);
      String message = "Constructor " + info.toString();
      if (args == null) message += "() not found";
      else message += "(" + args.toTypeString() + ") not found";
      throw ErrorFactory.createCompilerException(message);
    }
  }

  /*
   * This should only be called if the Name is on the rhs and not part of
   * a callOp or dotOp.
   */
  public void compile(NQPyBlockCompiler compiler) {
    ErrorFactory.setCurNode(this);
    String val = info.toString();
    if (type == NQPyBlockCompiler.NULL_NQPyClass) {
      // this will occur when the local variable is the only element in
      // a statement, e.g. print a.
      String message = "Undefined local variable '" + val + "'";
      throw ErrorFactory.createCompilerException(message);
    }

    if (val.equals("true")) compiler.emitInt(1);
    else if (val.equals("false")) compiler.emitInt(0);
    else if (val.equals("None")) compiler.emitNull();
    else compiler.emitLoadLocalVar(info.toString());
  }
}
