/* Generated By:JJTree: Do not edit this line. ASTSlice.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.ErrorFactory;
import uchicago.src.nqpy.compiler.NQPyBlockCompiler;
import uchicago.src.nqpy.compiler.NQPyClass;
import uchicago.src.nqpy.compiler.NQPyClassFactory;
import uchicago.src.nqpy.util.NQPyUtil;

import java.util.List;
import java.util.ArrayList;

public class ASTSlice extends SimpleNode {
  
  private static final NQPyClass INT_CLASS = NQPyClassFactory.makeIntegerClass();

  private int childCount = 0;
  private boolean startIs0 = false;
  private boolean endIsLength = false;
  private List intNodes = new ArrayList();

  public ASTSlice(int id) {
    super(id);
  }

  public ASTSlice(NQPyParser p, int id) {
    super(p, id);
  }

  private void setStartAndEnd() {
    ErrorFactory.setCurNode(this);
    childCount = children.length;
    if (childCount > 3) {
      String message = "Multi-item slice is not supported";
      throw ErrorFactory.createCompilerException(message);
    }

    if (childCount == 2) {
      // is the first child a colon
      if (((SimpleNode) children[0]).id == NQPyParserTreeConstants.JJTCOLON) {
        startIs0 = true;
        endIsLength = false;
        intNodes.add(children[1]);
      } else {
        startIs0 = false;
        endIsLength = true;
        intNodes.add(children[0]);
      }
    } else if (childCount == 1) {
      startIs0 = true;
      endIsLength = true;
    } else {
      // child count = 3
      intNodes.add(children[0]);
      intNodes.add(children[2]);
    }
  }

  public boolean isStartIs0() {
    return startIs0;
  }

  public boolean isEndIsLength() {
    return endIsLength;
  }
  
  public void compileForRange(NQPyBlockCompiler compiler, SimpleNode rangeNode) {
    compile(compiler);
    if (startIs0 && endIsLength) {
      String tmp = compiler.createTmp(int.class);
      compiler.emitDup();
      compiler.emitInvokeVirtual("uchicago.src.nqpy.builtin.range", "size", int.class, NQPyUtil.EMTPY_ARGS);
      compiler.emitStoreTmp(tmp);
      compiler.emitInt(0);
      compiler.emitLoadTmp(tmp);
    } else if (startIs0) {
      compiler.emitInt(0);
      ((SimpleNode)intNodes.get(0)).compile(compiler);
    } else if (endIsLength) {
      String tmp = compiler.createTmp(int.class);
      compiler.emitDup();
      compiler.emitInvokeVirtual("uchicago.src.nqpy.builtin.range", "size", int.class, NQPyUtil.EMTPY_ARGS);
      compiler.emitStoreTmp(tmp);
      ((SimpleNode)intNodes.get(0)).compile(compiler);
      compiler.emitLoadTmp(tmp);
    } else {
      ((SimpleNode)intNodes.get(0)).compile(compiler);
      ((SimpleNode)intNodes.get(1)).compile(compiler);
    }
  }
  
  public void compileForString(NQPyBlockCompiler compiler, SimpleNode rangeNode) {
    compile(compiler);
   if (startIs0 && endIsLength) {
      String tmp = compiler.createTmp(int.class);
      compiler.emitDup();
      compiler.emitInvokeVirtual("java.lang.String", "length", int.class, NQPyUtil.EMTPY_ARGS);
      compiler.emitStoreTmp(tmp);
      compiler.emitInt(0);
      compiler.emitLoadTmp(tmp);
    } else if (startIs0) {
      compiler.emitInt(0);
      ((SimpleNode)intNodes.get(0)).compile(compiler);
    } else if (endIsLength) {
      String tmp = compiler.createTmp(int.class);
      compiler.emitDup();
      compiler.emitInvokeVirtual("java.lang.String", "length", int.class, NQPyUtil.EMTPY_ARGS);
      compiler.emitStoreTmp(tmp);
      ((SimpleNode)intNodes.get(0)).compile(compiler);
      compiler.emitLoadTmp(tmp);
    } else {
      ((SimpleNode)intNodes.get(0)).compile(compiler);
      ((SimpleNode)intNodes.get(1)).compile(compiler);
    }
  }
  
  public void compileForList(NQPyBlockCompiler compiler) {
    compile(compiler);
    if (startIs0 && endIsLength) {
      String tmp = compiler.createTmp(int.class);
      compiler.emitDup();
      compiler.emitInvokeInterface("java.util.List", "size", int.class, NQPyUtil.EMTPY_ARGS);
      compiler.emitStoreTmp(tmp);
      compiler.emitInt(0);
      compiler.emitLoadTmp(tmp);
    } else if (startIs0) {
      compiler.emitInt(0);
      ((SimpleNode)intNodes.get(0)).compile(compiler);
    } else if (endIsLength) {
      String tmp = compiler.createTmp(int.class);
      compiler.emitDup();
      compiler.emitInvokeInterface("java.util.List", "size", int.class, NQPyUtil.EMTPY_ARGS);
      compiler.emitStoreTmp(tmp);
      ((SimpleNode)intNodes.get(0)).compile(compiler);
      compiler.emitLoadTmp(tmp);
    } else {
      ((SimpleNode)intNodes.get(0)).compile(compiler);
      ((SimpleNode)intNodes.get(1)).compile(compiler);
    }
  }

  public void compile(NQPyBlockCompiler compiler) {
    setStartAndEnd();
    for (int i = 0; i < intNodes.size(); i++) {
      SimpleNode node = (SimpleNode) intNodes.get(i);
      if (!node.getNQPyClass(compiler).equals(ASTSlice.INT_CLASS)) {
        ErrorFactory.setCurNode(this);
        String message = "Slice indices must be integers";
        throw ErrorFactory.createCompilerException(message);
      }
    }
  }
}
