/* Generated By:JJTree: Do not edit this line. ASTand_boolean.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.*;
import com.go.trove.classfile.Label;

public class ASTand_boolean extends SimpleNode
        implements NQPyParserTreeConstants {
  public ASTand_boolean(int id) {
    super(id);
  }

  public ASTand_boolean(NQPyParser p, int id) {
    super(p, id);
  }

  /**
   * Returns an NQPyInteger (a boolean 1 or 0)
   */
  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    return NQPyClassFactory.makeIntegerClass();
  }

  /**
   * When we want to leave the result of the and expression on
   * the stack. No branching.
   *
   * @param compiler
   */
  public void compile(NQPyBlockCompiler compiler) {
    SimpleNode lhs = (SimpleNode) children[0];
    NQPyClass nqtest = lhs.getNQPyClass(compiler);
    if (!nqtest.canBeBool()) {
      ErrorFactory.setCurNode(this);
      String message = "Invalid expression, must result in or be a boolean";
      throwError(message);
    }

    SimpleNode rhs = (SimpleNode) children[1];
    nqtest = rhs.getNQPyClass(compiler);
    if (!nqtest.canBeBool()) {
      ErrorFactory.setCurNode(this);
      String message = "Invalid expression, must result in or be a boolean";
      throwError(message);
    }

    Label falseBranch = compiler.createLabel();
    Label postFalseBranch = compiler.createLabel();

    lhs.compile(compiler);
    compiler.emitEqZero(falseBranch);
    rhs.compile(compiler);
    compiler.emitEqZero(falseBranch);
    compiler.emitInt(1);
    compiler.emitGoto(postFalseBranch);
    falseBranch.setLocation();
    compiler.emitInt(0);
    postFalseBranch.setLocation();
  }

  /**
   * The falseBranch is where to go if either of the children of this
   * and are false.
   */
  public void compile(NQPyBlockCompiler compiler, Label falseBranch) {
    SimpleNode lhs = (SimpleNode) children[0];
    SimpleNode rhs = (SimpleNode) children[1];

    // for child or_booleans
    Label trueBranch = compiler.createLabel();
    compileNode(lhs, compiler, trueBranch, falseBranch);
    trueBranch.setLocation();
    trueBranch = compiler.createLabel();
    compileNode(rhs, compiler, trueBranch, falseBranch);
    trueBranch.setLocation();
  }

  private void compileNode(SimpleNode node, NQPyBlockCompiler compiler,
                           Label trueBranch, Label falseBranch) {

    switch (node.id) {
      case JJTAND_BOOLEAN:
        ((ASTand_boolean) node).compile(compiler, falseBranch);
        break;
      case JJTOR_BOOLEAN:
        ((ASTor_boolean) node).compile(compiler, trueBranch, falseBranch);
        break;
      case JJTCOMPARISION:
        ((ASTcomparision) node).compileBranchFalse(compiler, falseBranch);
        break;
      default:
        NQPyClass nqtest = node.getNQPyClass(compiler);
        if (!nqtest.canBeBool()) {
          ErrorFactory.setCurNode(this);
          String message = "Invalid expression, must result in or be a boolean";
          throwError(message);
        } else {
          ErrorFactory.setCurNode(node);
          Emitter emitter = nqtest.getEmitter();
          emitter.branchOnFalse(node, compiler, falseBranch);
        }
    }
  }
}
