/* Generated By:JJTree: Do not edit this line. ASTcomparision.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.*;
import com.go.trove.classfile.Label;

public class ASTcomparision extends SimpleNode implements
  NQPyParserTreeConstants
{

  public ASTcomparision(int id) {
    super(id);
  }

  public ASTcomparision(NQPyParser p, int id) {
    super(p, id);
  }

  /**
   * Returns an NQPyInteger (a boolean 1 or 0)
   */
  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    return NQPyClassFactory.makeIntegerClass();
  }

  /**
   * Called when this ASTcomparision is called in the context
   * of a "branch statement" (i.e. if etc.). This will branch to the
   * specified branch if the comparison is true, rather than leaving
   * the result of the comparison on the stack.
   */
  public void compile(NQPyBlockCompiler compiler, Label branch) {
    ErrorFactory.setCurNode(this);
    int id = ((SimpleNode)children[1]).id;
    NQPyClass lhs = children[0].getNQPyClass(compiler);
    NQPyClass rhs = children[2].getNQPyClass(compiler);

    if (lhs == NQPyBlockCompiler.NULL_NQPyClass) {
      String val = ((SimpleNode)children[0]).info.toString();
      String message = "Undefined variable '" + val + "'";
      throw ErrorFactory.createCompilerException(message);
    }

    SimpleNode rhsNode = (SimpleNode)children[2]; 
    if (rhsNode.id == JJTNAME && rhsNode.getInfo().equals("None")) {
      // make sure id is an equal cmp
      if (id == JJTEQUAL_CMP) {
        children[0].compile(compiler);
        // don't need to compile the rhs null onto the stack
        // as we can do a straight check for null rather than
        // a comparison
        compiler.emitIfNull(branch);
      } else if (id == JJTNOTEQUAL_CMP) {
        children[0].compile(compiler);
        // don't need to compile the rhs null onto the stack
        // as we can do a straight check for null rather than
        // a comparison
        compiler.emitIfNotNull(branch);
      } else {
        String message = "Only equality comparisons are supported for 'None'";
        throw ErrorFactory.createCompilerException(message);
      }
      return;
    }
    
    if (rhs == NQPyBlockCompiler.NULL_NQPyClass) {
      String val = ((SimpleNode)children[2]).info.toString();
      String message = "Undefined variable '" + val + "'";
      throw ErrorFactory.createCompilerException(message);
    }
    
    Emitter emitter;
    
    switch (id) {
    case JJTEQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.eq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTNOTEQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.notEq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTGREATER_CMP:
      emitter = lhs.getEmitter();
      emitter.gt(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTLESS_CMP:
      emitter = lhs.getEmitter();
      emitter.lt(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTGREATER_EQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.gtEq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTLESS_EQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.ltEq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

      
    default:
      throwError("unsupported comparison operation");
    }
  }

  /**
   * Called when this ASTcomparision is called in the context
   * of a "branch statement" (i.e. if etc.). This will branch to the
   * specified branch if the comparison is false, rather than leaving
   * the result of the comparison on the stack.
   */
  public void compileBranchFalse(NQPyBlockCompiler compiler, Label branch) {
    ErrorFactory.setCurNode(this);
    int id = ((SimpleNode)children[1]).id;
    NQPyClass lhs = children[0].getNQPyClass(compiler);
    NQPyClass rhs = children[2].getNQPyClass(compiler);
    Emitter emitter;
    
    SimpleNode rhsNode = (SimpleNode)children[2]; 
    if (rhsNode.id == JJTNAME && rhsNode.getInfo().equals("None")) {
      // make sure id is an equal cmp
      if (id == JJTEQUAL_CMP) {
        children[0].compile(compiler);
        // don't need to compile the rhs null onto the stack
        // as we can do a straight check for null rather than
        // a comparison
        compiler.emitIfNotNull(branch);
      } else if (id == JJTNOTEQUAL_CMP) {
        children[0].compile(compiler);
        // don't need to compile the rhs null onto the stack
        // as we can do a straight check for null rather than
        // a comparison
        compiler.emitIfNull(branch);
      } else {
        String message = "Only equality comparisons are supported with 'None'";
        throw ErrorFactory.createCompilerException(message);
      }
      return;
    }
    
    switch (id) {
    case JJTEQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.notEq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTNOTEQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.eq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTGREATER_CMP:
      emitter = lhs.getEmitter();
      emitter.ltEq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTLESS_CMP:
      emitter = lhs.getEmitter();
      emitter.gtEq(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTGREATER_EQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.lt(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

    case JJTLESS_EQUAL_CMP:
      emitter = lhs.getEmitter();
      emitter.gt(rhs, (SimpleNode)children[0], (SimpleNode)children[2],
		 branch, compiler);
      break;

      
    default:
      throwError("unsupported comparison operation");
    }
  }

  public void compile(NQPyBlockCompiler compiler) {
    Label branch = compiler.createLabel();
    Label end = compiler.createLabel();
    compile(compiler, branch);
    compiler.emitInt(0);
    compiler.emitGoto(end);
    branch.setLocation();
    compiler.emitInt(1);
    end.setLocation();
  }
}
  
	
