/* Generated By:JJTree: Do not edit this line. ASTfor_stmt.java */

package uchicago.src.nqpy.parser;

import com.go.trove.classfile.Label;
import uchicago.src.nqpy.compiler.*;
import uchicago.src.nqpy.util.ArrayData;

public class ASTfor_stmt extends SimpleNode {

  private NQPyClass listType;
  private Label start, end, check;
  private boolean hasElse;
  private Class arrayComponentType = null;

  public ASTfor_stmt(int id) {
    super(id);
  }

  public ASTfor_stmt(NQPyParser p, int id) {
    super(p, id);
  }

  public void compile(NQPyBlockCompiler compiler) {
    ErrorFactory.setCurNode(this);
    start = compiler.createLabel();
    end = compiler.createLabel();
    check = compiler.createLabel();
    int len = jjtGetNumChildren();
    if (((SimpleNode) children[len - 2]).id == NQPyParserTreeConstants.JJTSUITE
            &&
            ((SimpleNode) children[len - 1]).id == NQPyParserTreeConstants.JJTSUITE) {
      hasElse = true;
    }

    compiler.pushLoopData(start, end, check);
    setListType(compiler);
    varCheck();
    if (hasElse) {
      if (len == 5)
        compileCast(compiler);
      else
        compileNoCast(compiler);
    } else {
      if (len == 4)
        compileCast(compiler);
      else
        compileNoCast(compiler);
    }

    compiler.popLoopData();

  }

  private void setListType(NQPyBlockCompiler compiler) {
    int listIndex = 2;
    if (hasElse) listIndex = 3;
    SimpleNode list = (SimpleNode) children[jjtGetNumChildren() - listIndex];
    listType = list.getNQPyClass(compiler);

    if (listType.getJClass() == null) {
      String message = "Undefined local variable '" + list.getInfo().toString() +
              "' cannot be used as a sequence";
      throw ErrorFactory.createCompilerException(message);
    }

    if (listType.getJClass().equals(uchicago.src.nqpy.builtin.range.class)) return;

    if (ArrayData.isArray(listType)) {
      ArrayData data = new ArrayData(listType);
      if (data.getDimensions() > 1) {
        String message = "Loop over multi-dimensional array is not supported.";
        throw ErrorFactory.createCompilerException(message);
      }

      arrayComponentType = data.getComponentType();
      return;
    }

    if (!listType.inObjHeirarchy(NQPyClassFactory.
            makeNQPyClass(java.util.Collection.class))) {
      String message = "Loop over non-sequence; sequence " +
              "must implement java.util.Collection";
      throw ErrorFactory.createCompilerException(message);
    }
  }

  private void varCheck() {
    SimpleNode var = (SimpleNode) children[0];
    if (var.id != NQPyParserTreeConstants.JJTNAME) {
      String message = "Assignee in for statement must be a single variable";
      throw ErrorFactory.createCompilerException(message);
    }
  }

  private void compileNoCast(NQPyBlockCompiler compiler) {
    boolean isRange = listType.getJClassName().equals("uchicago.src.nqpy.builtin.range");
    NQPyClass nq = NQPyClassFactory.makeNQPyClass(java.util.Iterator.class);
    MethodCall iterNext = nq.getMethodCall("next", new NQPyClass[]{});
    MethodCall iterHasNext = nq.getMethodCall("hasNext", new NQPyClass[]{});
    String varName = (String) ((SimpleNode) children[0]).getInfo();
    if (isRange) {
      compiler.emitLocalVarNoCheck(varName, NQPyClassFactory.makeIntegerClass());
    } else if (arrayComponentType != null) {
      compiler.emitLocalVarNoCheck(varName, NQPyClassFactory.makeNQPyClass(arrayComponentType));
    } else {
      compiler.emitLocalVarNoCheck(varName, NQPyClassFactory.makeNQPyClass(Object.class));
    }
    // compile the sequence part of the for stmt.
    children[1].compile(compiler);
    if (arrayComponentType != null) {
      String array = compiler.createTmp(listType.getJClass());
      compiler.emitStoreTmp(array);
      compiler.emitLoadTmp(array);
      compiler.emitArrayLength();
      String length = compiler.createTmp(int.class);
      compiler.emitStoreTmp(length);
      String index = compiler.createTmp(int.class);
      compiler.emitInt(0);
      compiler.emitStoreTmp(index);
      compiler.emitGoto(check);
      start.setLocation();
      // get the value from the array and store it in the local var
      // then compile the body of the for loop
      compiler.emitLoadTmp(array);
      compiler.emitLoadTmp(index);
      compiler.emitLoadFromArray(arrayComponentType);
      compiler.emitStoreLocal(varName);
      children[2].compile(compiler);
      compiler.emitIncTmp(index, 1);
      check.setLocation();
      compiler.emitLoadTmp(index);
      compiler.emitLoadTmp(length);
      compiler.emitIntComp(start, "<");
  
    } else {
      MethodCall c = listType.getMethodCall("iterator", new NQPyClass[]{});
      compiler.emitInvokeMethod(c);
      String iter = compiler.createTmp(java.util.Iterator.class);
      compiler.emitStoreTmp(iter);
      compiler.emitGoto(check);
      start.setLocation();
      compiler.emitLoadTmp(iter);
      compiler.emitInvokeMethod(iterNext);
      if (isRange) {
        NQPyClass integerClass = NQPyClassFactory.makeNQPyClass(Integer.class);
        compiler.emitCast(integerClass);
        compiler.emitInvokeMethod(integerClass.getMethodCall("intValue", new NQPyClass[]{}));
      }
      compiler.emitStoreLocal(varName);
      // compile the suite
      children[2].compile(compiler);
      check.setLocation();
      compiler.emitLoadTmp(iter);
      compiler.emitInvokeMethod(iterHasNext);
      compiler.emitNotEqZero(start);
    }

    if (hasElse) children[3].compile(compiler);
    end.setLocation();
  }

  private void compileCast(NQPyBlockCompiler compiler) {
    String castTo = ((ASTdotted_name) children[1]).getName();
    NQPyClass castClass = NQPyClassFactory.makeJavaClass(castTo);
    if (castClass == null) {
      String message = "Cast class '" + castTo + "' not found";
      throw ErrorFactory.createCompilerException(message);
    }

    NQPyClass nq = NQPyClassFactory.makeNQPyClass(java.util.Iterator.class);
    MethodCall iterNext = nq.getMethodCall("next", new NQPyClass[]{});
    MethodCall iterHasNext = nq.getMethodCall("hasNext", new NQPyClass[]{});
    String varName = (String) ((SimpleNode) children[0]).getInfo();
    compiler.emitLocalVarNoCheck(varName, castClass);
    children[2].compile(compiler);
    MethodCall c = listType.getMethodCall("iterator", new NQPyClass[]{});
    compiler.emitInvokeMethod(c);
    String iter = compiler.createTmp(java.util.Iterator.class);
    compiler.emitStoreTmp(iter);
    compiler.emitGoto(check);
    start.setLocation();
    compiler.emitLoadTmp(iter);
    compiler.emitInvokeMethod(iterNext);
    compiler.emitCast(castClass);
    compiler.emitStoreLocal(varName);
    // compile the suite
    children[3].compile(compiler);
    check.setLocation();
    compiler.emitLoadTmp(iter);
    compiler.emitInvokeMethod(iterHasNext);
    compiler.emitNotEqZero(start);

    if (hasElse) children[4].compile(compiler);
    end.setLocation();
  }
}
