/* Generated By:JJTree: Do not edit this line. ASTif_stmt.java */

package uchicago.src.nqpy.parser;

import com.go.trove.classfile.Label;
import uchicago.src.nqpy.compiler.Emitter;
import uchicago.src.nqpy.compiler.ErrorFactory;
import uchicago.src.nqpy.compiler.NQPyBlockCompiler;
import uchicago.src.nqpy.compiler.NQPyClass;

import java.util.ArrayList;

public class ASTif_stmt extends SimpleNode {
  public ASTif_stmt(int id) {
    super(id);
  }

  public ASTif_stmt(NQPyParser p, int id) {
    super(p, id);
  }

  private boolean containsAndOr(int len) {
    for (int i = 0; i < len; i++) {
      SimpleNode node = (SimpleNode) children[i];
      if (node.id == NQPyParserTreeConstants.JJTAND_BOOLEAN ||
              node.id == NQPyParserTreeConstants.JJTOR_BOOLEAN) {
        return true;
      }
    }
    return false;
  }

  public void compile(NQPyBlockCompiler compiler) {
    int len = jjtGetNumChildren();
    if (len == 2)
      makeSimpleIf(compiler);
    else if (containsAndOr(len))
      makeComplexIfAndOr(compiler, len);
    else
      makeComplexIf(compiler, len);
  }

  private void makeSimpleIf(NQPyBlockCompiler compiler) {

    SimpleNode test = (SimpleNode) children[0];
    SimpleNode suite = (SimpleNode) children[1];

    if (test.id == NQPyParserTreeConstants.JJTCOMPARISION) {
      ASTcomparision comp = (ASTcomparision) test;
      Label start = compiler.createLabel();
      comp.compile(compiler, start);
      Label end = compiler.createLabel();
      compiler.emitGoto(end);
      start.setLocation();
      suite.compile(compiler);
      end.setLocation();
    } else if (test.id == NQPyParserTreeConstants.JJTAND_BOOLEAN) {
      ASTand_boolean bool = (ASTand_boolean) test;
      Label end = compiler.createLabel();
      bool.compile(compiler, end);
      suite.compile(compiler);
      end.setLocation();
    } else if (test.id == NQPyParserTreeConstants.JJTOR_BOOLEAN) {
      ASTor_boolean bool = (ASTor_boolean) test;
      Label end = compiler.createLabel();
      Label start = compiler.createLabel();
      bool.compile(compiler, start, end);
      start.setLocation();
      suite.compile(compiler);
      end.setLocation();
    } else {
      NQPyClass nqtest = test.getNQPyClass(compiler);
      if (!nqtest.canBeBool()) {
        ErrorFactory.setCurNode(this);
        String message = "Invalid expression, must result in or be a boolean";
        throwError(message);
      } else {
        ErrorFactory.setCurNode(test);
        Emitter emitter = nqtest.getEmitter();
        Label end = compiler.createLabel();
        emitter.branchOnFalse(test, compiler, end);
        suite.compile(compiler);
        end.setLocation();
      }
    }
  }

  private void makeComplexIfAndOr(NQPyBlockCompiler compiler, int len) {
    ArrayList suites = new ArrayList();
    ArrayList tests = new ArrayList();
    Label end = compiler.createLabel();

    boolean hasElse = (len % 2 != 0);
    ErrorFactory.setCurNode(this);
    for (int i = 0; i < len; i++) {
      SimpleNode node = (SimpleNode) children[i];
      if (node.id == NQPyParserTreeConstants.JJTSUITE)
        suites.add(node);
      else
        tests.add(node);
    }

    Label nextTest = compiler.createLabel();

    for (int i = 0; i < tests.size(); i++) {
      Label suiteStart = null;
      SimpleNode test = (SimpleNode) tests.get(i);
      if (test.id == NQPyParserTreeConstants.JJTCOMPARISION) {
        ASTcomparision comp = (ASTcomparision) test;
        comp.compileBranchFalse(compiler, nextTest);
      } else if (test.id == NQPyParserTreeConstants.JJTAND_BOOLEAN) {
        ASTand_boolean bool = (ASTand_boolean) test;
        bool.compile(compiler, nextTest);
      } else if (test.id == NQPyParserTreeConstants.JJTOR_BOOLEAN) {
        ASTor_boolean bool = (ASTor_boolean) test;
        suiteStart = compiler.createLabel();
        bool.compile(compiler, suiteStart, nextTest);
      } else {
        NQPyClass nqtest = test.getNQPyClass(compiler);
        if (!nqtest.canBeBool()) {
          ErrorFactory.setCurNode(this);
          String message = "Invalid expression, must result in or be a boolean";
          throwError(message);
        } else {
          ErrorFactory.setCurNode(test);
          Emitter emitter = nqtest.getEmitter();
          emitter.branchOnFalse(test, compiler, nextTest);
        }
      }

      SimpleNode suite = (SimpleNode) suites.get(i);
      if (suiteStart != null) suiteStart.setLocation();
      suite.compile(compiler);
      compiler.emitGoto(end);

      nextTest.setLocation();
      nextTest = compiler.createLabel();
    }

    if (hasElse) {
      SimpleNode suite = (SimpleNode) suites.get(suites.size() - 1);
      suite.compile(compiler);
    }

    end.setLocation();
  }

  /*
   * Idea here is that the all the tests are created first. If true
   * then they go to the start of their suite. If all fail then falls through
   * to the "else" suite if there is one.
   */
  private void makeComplexIf(NQPyBlockCompiler compiler, int len) {
    ArrayList suites = new ArrayList();
    ArrayList labels = new ArrayList();

    boolean hasElse = (len % 2 != 0);
    Label end = compiler.createLabel();
    ErrorFactory.setCurNode(this);

    for (int i = 0; i < len; i++) {
      SimpleNode node = (SimpleNode) children[i];
      if (node.id == NQPyParserTreeConstants.JJTSUITE) {
        if (i == len - 1 && hasElse) {
          // compile else suite as first block so if all fail
          // then falls through to else
          // node here is a suite
          node.compile(compiler);
          compiler.emitGoto(end);
        } else {
          suites.add(node);
        }
      } else if (node.id == NQPyParserTreeConstants.JJTCOMPARISION) {
        ASTcomparision comp = (ASTcomparision) node;
        Label suiteStart = compiler.createLabel();
        comp.compile(compiler, suiteStart);
        labels.add(suiteStart);
      } else {
        NQPyClass nqtest = node.getNQPyClass(compiler);
        if (!nqtest.canBeBool()) {
          String message = "invalid test clause";
          throwError(message);
        } else {
          Emitter emitter = nqtest.getEmitter();
          Label suiteStart = compiler.createLabel();
          emitter.branchOnTrue(node, compiler, suiteStart);
          labels.add(suiteStart);
        }
      }
    }

    for (int i = 0; i < suites.size(); i++) {
      Label start = (Label) labels.get(i);
      SimpleNode node = (SimpleNode) suites.get(i);
      start.setLocation();
      node.compile(compiler);
      compiler.emitGoto(end);
    }

    end.setLocation();
  }
}
