/* Generated By:JJTree: Do not edit this line. ASTor_boolean.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.*;
import com.go.trove.classfile.Label;


public class ASTor_boolean extends SimpleNode
  implements NQPyParserTreeConstants
{
  public ASTor_boolean(int id) {
    super(id);
  }

  public ASTor_boolean(NQPyParser p, int id) {
    super(p, id);
  }

  /**
   * Returns an NQPyInteger (a boolean 1 or 0)
   */
  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    return NQPyClassFactory.makeIntegerClass();
  }

  /**
     * When we want to leave the result of the or expression on
     * the stack. No branching.
     *
     * @param compiler
     */
    public void compile(NQPyBlockCompiler compiler) {
      SimpleNode lhs = (SimpleNode) children[0];
      NQPyClass nqtest = lhs.getNQPyClass(compiler);
      if (!nqtest.canBeBool()) {
        ErrorFactory.setCurNode(this);
        String message = "Invalid expression, must result in or be a boolean";
        throwError(message);
      }

      SimpleNode rhs = (SimpleNode) children[1];
      nqtest = rhs.getNQPyClass(compiler);
      if (!nqtest.canBeBool()) {
        ErrorFactory.setCurNode(this);
        String message = "Invalid expression, must result in or be a boolean";
        throwError(message);
      }

      Label trueBranch = compiler.createLabel();
      Label postFalseBranch = compiler.createLabel();

      lhs.compile(compiler);
      compiler.emitNotEqZero(trueBranch);
      rhs.compile(compiler);
      compiler.emitNotEqZero(trueBranch);
      // fall through on false
      compiler.emitInt(0);
      compiler.emitGoto(postFalseBranch);
      trueBranch.setLocation();
      compiler.emitInt(1);
      postFalseBranch.setLocation();
    }


  /**
   * The falseBranch is where to go if both of the children of this
   * and are false. trueBranch is where to go if lhs child is true,
   * otherwise assume that rhs on true falls through to next bytecode.
   */
  public void compile(NQPyBlockCompiler compiler, Label trueBranch,
		      Label falseBranch)
  {
    SimpleNode lhs = (SimpleNode)children[0];
    SimpleNode rhs = (SimpleNode)children[1];

    // in an "or" if the lhs is false, then we need to evalute the
    // rhs rather then proceeding immediate to the parent false branch.
    // This label marks the beginning of the rhs evaluation.
    Label nextArg = compiler.createLabel();
    compileLhs(lhs, compiler, trueBranch, nextArg);
    nextArg.setLocation();
    compileRhs(rhs, compiler, trueBranch, falseBranch);
  }

  /*
   * This branchs to the specified branch if the node evaluates to true,
   * as opposed to compileRhs which branches on false.
   */
  private void compileLhs(SimpleNode node, NQPyBlockCompiler compiler,
			  Label trueBranch, Label falseBranch)
  {
    switch (node.id) {
    case JJTAND_BOOLEAN:
      ((ASTand_boolean)node).compile(compiler, falseBranch);
      compiler.emitGoto(trueBranch);
      break;
    case JJTOR_BOOLEAN:
      ((ASTor_boolean)node).compile(compiler, trueBranch, falseBranch);
      break;
    case JJTCOMPARISION:
      ((ASTcomparision)node).compile(compiler, trueBranch);
      break;
    default:
      NQPyClass nqtest = node.getNQPyClass(compiler);
      if (!nqtest.canBeBool()) {
	ErrorFactory.setCurNode(this);
	String message = "Invalid expression, must result in or be a boolean";
	throwError(message);
      } else {
	ErrorFactory.setCurNode(node);
	Emitter emitter = nqtest.getEmitter();
	emitter.branchOnTrue(node, compiler, trueBranch);
      }
    }
  }

  private void compileRhs(SimpleNode node, NQPyBlockCompiler compiler,
			  Label trueBranch, Label falseBranch)
  {

    switch (node.id) {
    case JJTAND_BOOLEAN:
      ((ASTand_boolean)node).compile(compiler, falseBranch);
      break;
    case JJTOR_BOOLEAN:
      ((ASTor_boolean)node).compile(compiler, trueBranch, falseBranch);
      break;
    case JJTCOMPARISION:
      ((ASTcomparision)node).compileBranchFalse(compiler, falseBranch);
      break;
    default:
      NQPyClass nqtest = node.getNQPyClass(compiler);
      if (!nqtest.canBeBool()) {
	ErrorFactory.setCurNode(this);
	String message = "Invalid expression, must result in or be a boolean";
	throwError(message);
      } else {
	ErrorFactory.setCurNode(node);
	Emitter emitter = nqtest.getEmitter();
	emitter.branchOnFalse(node, compiler, falseBranch);
      }
    }
  }
}
