/* Generated By:JJTree: Do not edit this line. SimpleNode.java */

package uchicago.src.nqpy.parser;

import uchicago.src.nqpy.compiler.ErrorFactory;
import uchicago.src.nqpy.compiler.NQPyBlockCompiler;
import uchicago.src.nqpy.compiler.NQPyClass;

public class SimpleNode implements Node {
  protected Node parent;
  protected Node[] children;
  protected int id;
  protected NQPyParser parser;
  public int endLine, endColumn, beginLine, beginColumn;
  Object info;

  public SimpleNode(int i) {
    id = i;
  }

  public SimpleNode(NQPyParser p, int i) {
    this(i);
    parser = p;
  }

  public void jjtOpen() {
  }

  public void jjtClose() {
  }

  public void jjtSetParent(Node n) {
    parent = n;
  }

  public Node jjtGetParent() {
    return parent;
  }

  public void jjtAddChild(Node n, int i) {
    if (children == null) {
      children = new Node[i + 1];
    } else if (i >= children.length) {
      Node c[] = new Node[i + 1];
      System.arraycopy(children, 0, c, 0, children.length);
      children = c;
    }
    children[i] = n;
  }

  public Node jjtGetChild(int i) {
    return children[i];
  }

  public int jjtGetNumChildren() {
    return (children == null) ? 0 : children.length;
  }

  /* You can override these two methods in subclasses of SimpleNode to
     customize the way the node appears when the tree is dumped.  If
     your output uses more than one line you should override
     toString(String), otherwise overriding toString() is probably all
     you need to do. */

  public String toString() {
    return NQPyParserTreeConstants.jjtNodeName[id] + ": " + info;
  }

  public String toString(String prefix) {
    return prefix + toString();
  }

  /* Override this method if you want to customize how the node dumps
     out its children. */

  public void dump(String prefix) {
    System.out.println(toString(prefix));
    if (children != null) {
      for (int i = 0; i < children.length; ++i) {
        SimpleNode n = (SimpleNode) children[i];
        if (n != null) {
          n.dump(prefix + " ");
        }
      }
    }
  }


  public Object getInfo() {
    return info;
  }

  public void setInfo(Object o) {
    info = o;
    //System.out.println("name: "+info);
  }


  public void setString(String s, int quotes) {
    info = parseString(s, quotes, beginLine, beginColumn);
  }

  public String parseString(String str, int quotes, int beginLine, int beginColumn) {
    // this code comes from the jython sources -- PyString.emit_UnicodeEscapes
    // or something like it.
    int end = str.length() - quotes;
    StringBuffer v = new StringBuffer(str.length() - quotes);
    for (int s = quotes; s < end;) {
      char ch = str.charAt(s);
      if (ch != '\\') {
        v.append(ch);
        s++;
        continue;
      }

      /* \ - Escapes */
      s++;
      ch = str.charAt(s++);
      switch (ch) {

        /* \x escapes */
        case '\n':
          break;
        case '\\':
          v.append('\\');
          break;
        case '\'':
          v.append('\'');
          break;
        case '\"':
          v.append('\"');
          break;
        case 'b':
          v.append('\b');
          break;
        case 'f':
          v.append('\014');
          break; /* FF */
        case 't':
          v.append('\t');
          break;
        case 'n':
          v.append('\n');
          break;
        case 'r':
          v.append('\r');
          break;
        case 'v':
          v.append('\013');
          break; /* VT */
        case 'a':
          v.append('\007');
          break; /* BEL, not classic C */

        default:
          v.append('\\');
          v.append(str.charAt(s - 1));
          break;
      }
    }
    return v.toString();
  }

  protected void throwError(String message, Exception ex) {
    ErrorFactory.setCurNode(this);
    throw ErrorFactory.createCompilerException(message, ex);
  }

  protected void throwError(String message) {
    ErrorFactory.setCurNode(this);
    throw ErrorFactory.createCompilerException(message);
  }

  public void setInteger(String s, int radix) {
    if (s.endsWith("L") || s.endsWith("l")) {
      s = s.substring(0, s.length() - 1);
      try {
        setInfo(Long.valueOf(s, radix));
      } catch (NumberFormatException ex) {
        String message = "Error creating long value";
        throwError(message, ex);
      }
    } else {
      int ndigits = s.length();
      int i = 0;
      while (i < ndigits && s.charAt(i) == '0') i++;
      if ((ndigits - i) > 11) {
        throwError("Integer literal too large");
      }

      long l = Long.valueOf(s, radix).longValue();
      if (l > 0xffffffffl || (radix == 10 && l > Integer.MAX_VALUE)) {
        throwError("Integer literal too large");
      }
      setInfo(new Integer((int) l));
    }
  }


  public void setFloat(String s) {
    if (s.endsWith("F") || s.endsWith("f")) {
      s = s.substring(0, s.length() - 1);
      try {
        setInfo(Float.valueOf(s));
      } catch (NumberFormatException ex) {
        String message = "Error creating float value";
        throwError(message, ex);
      }
    } else {
      setInfo(Double.valueOf(s));
    }
  }

  /* Compilation methods */
  public void compile(NQPyBlockCompiler compiler) {
    ErrorFactory.setCurNode(this);
    String message = "Unrecognized expression; compilation not supported on " +
            NQPyParserTreeConstants.jjtNodeName[id];

    throw ErrorFactory.createCompilerException(message);
  }

  public NQPyClass getNQPyClass(NQPyBlockCompiler compiler) {
    ErrorFactory.setCurNode(this);
    String message = "getNQPyClass not supported on " +
            NQPyParserTreeConstants.jjtNodeName[id];

    throw ErrorFactory.createCompilerException(message);
  }

  /*
   * Called when getting NQPyClass of ASTName in the context of
   * a call op.
   */
  public NQPyClass getNQPyClassCallOp(NQPyBlockCompiler compiler,
                                      ASTarglist args) {
    ErrorFactory.setCurNode(this);
    String message = "getNQPyClassCallOp not supported on " +
            NQPyParserTreeConstants.jjtNodeName[id];

    throw ErrorFactory.createCompilerException(message);
  }
}

