package uchicago.src.nqpy.util;

import java.util.List;
import java.util.ArrayList;

/**
 * Utility methods used in by nqpy compiler.
 * <p/>
 * $Revision: 1.2 $ $Date: 2004/10/12 13:19:25 $
 */
public class NQPyUtil {

  public static final Class[] EMTPY_ARGS = new Class[0];

  /**
   * Capitalizes the specified String.
   *
   * @param val
   * @return
   */
  public static String capitalize(String val) {
    StringBuffer b = new StringBuffer(val);
    char cap = Character.toUpperCase(b.charAt(0));
    b.setCharAt(0, cap);
    return b.toString();
  }

  /**
   * Performs a python like get or index op on a List. Lists in python can be indexed
   * with negative indexes. This method wraps that functionality.
   *
   * @param list
   * @param index
   * @return
   */
  public static Object get(List list, int index) {
    if (index < 0) {
      return list.get(list.size() + index);
    }

    return list.get(index);
  }

  public static void set(List list, int index, Object obj) {
    if (index < 0) index = list.size() + index;
    list.set(index, obj);
  }

  public static String get(String string, int index) {
    char c;
    if (index < 0) {
      c = string.charAt(string.length() + index);
    } else {
      c = string.charAt(index);
    }
    return String.valueOf(c);
  }

  public static List sublist(List list, int start, int end) {
    if (start < 0) {
      start = list.size() + start;
    }

    if (end < 0) {
      end = list.size() + end;
    }

    if (start <= end) return list.subList(start, end);
    return new ArrayList();
  }

  public static String substring(String string, int start, int end) {
    if (start < 0) {
      start = string.length() + start;
    }

    if (end < 0) {
      end = string.length() + end;
    }

    if (start <= end) return string.substring(start, end);
    return "";
  }
}
