package uchicago.src.simbuilder.base;

import uchicago.src.sim.engine.Schedule;
import uchicago.src.sim.engine.SimModelImpl;
import uchicago.src.sim.util.Random;

import java.util.ArrayList;

public class DefaultSimModelImpl extends SimModelImpl {

  protected ArrayList agentList;
  protected Schedule schedule;
  protected String[] params;
  //protected DisplaySurface surface;
  protected String name;

  protected void buildDisplay() {
    _display();
  }

  protected void buildSchedule() {
    //schedule.scheduleActionBeginning(1, agentList, "step");
    _schedule();
  }

  /**
   * This should maybe implemented by dynamic subclass..
   */
  public void _display() {
  }

  /**
   * This should be implemented by dynamic subclass.
   */
  public void _build() {
  }

  /**
   * This should be implemented by dynamic subclass.
   */
  public void _setup() {
  }

  public void _schedule() {
  }

  public void begin() {
    _build();
    buildDisplay();
    buildSchedule();

    //if (surface != null) surface.display();
  }

  public void setup() {
    Random.createUniform();
    //if (surface != null) surface.dispose();
    //surface = null;
    schedule = null;

    schedule = new Schedule();
    agentList = new ArrayList();

    _setup();

    System.gc();
  }

  public ArrayList getAgentList() {
    return agentList;
  }

  public String[] getInitParam() {
    return params;
  }

  public Schedule getSchedule() {
    return schedule;
  }

  public String getName() {
    return name;
  }

  public Class getClassByName(String name) {
    //System.out.println(name);
    try {
      return Class.forName(name, true, this.getClass().getClassLoader());
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    return null;
  }
}
