package uchicago.src.simbuilder.base.gis;

import uchicago.src.sim.engine.CustomProbeable;
import anl.repast.gis.GisAgent;

import java.awt.*;
import java.util.HashMap;
import java.util.Map;

import com.bbn.openmap.omGraphics.OMGraphic;

/**
 * Abstract base class upon which the classes compiled from VectorAgent producers are based.
 */ 
public abstract class AbstractGISAgent implements CustomProbeable, GisAgent {
  
  protected int index;
  protected OMGraphic omGraphic;
  protected Map drawingMap = new HashMap();
  protected Color defaultColor;
  protected LineSetter defaultLineSetter;
  protected int[] neighbors = new int[0];
  
  public AbstractGISAgent() {
    initDrawingMap();
  }
  
  protected void initDrawingMap() {}

  public Paint getFillPaint() {
    Color color = setupDraw();
    Color override = setupCustomDraw();
    return override == null ? color : override;
  }
  
  public Color setupDraw() {
    return null;
  }
  
  public Color setupCustomDraw() {
    return null;
  }

  public int getGisAgentIndex() {
    return index;  
  }

  public int[] getNeighbors() {
    return neighbors;
  }

  public OMGraphic getOMGraphic() {
    return omGraphic;
  }
  
  public void setOMGraphic(OMGraphic graphic) {
    omGraphic = graphic;
  }

  public String[] gisPropertyList() {
    return new String[0];  
  }

  public void setGisAgentIndex(int index) {
    this.index = index;
  }

  public void setNeighbors(int[] neighbors) {
    this.neighbors = neighbors;
  }
}
