package uchicago.src.simbuilder.beans;

import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyEditorManager;
import java.io.Serializable;

public abstract class AbstractEvolverCompileable implements EvolverCompileable,
        Serializable {
  protected PropertyChangeSupport pcs;
  protected String pkg = "";

  static {
    PropertyEditorManager.
            registerEditor(uchicago.src.simbuilder.beans.ScheduleDetails.class,
                    uchicago.src.simbuilder.beans.ScheduleDetailsPropertyEditor.class);
  }

  public void addPropertyChangeListener(PropertyChangeListener l) {
    pcs.addPropertyChangeListener(l);
  }

  public void removePropertyChangeListener(PropertyChangeListener l) {
    pcs.removePropertyChangeListener(l);
  }

  public void setPackage(String pkg) {
    this.pkg = pkg;
  }
}
