package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Editor for Actions properties.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:25 $
 */

public class ActionsPropertyEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private JLabel label = EvolverPropertyEditor.getLabel();
  private Actions actions = new Actions();

  public ActionsPropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Actions");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    //if (edited || first) {
    //System.out.println("actions set value"
    actions = new Actions((Actions) val);
    label.setText(actions.size() + " action(s)");
    //first = false;
    //}
  }

  public Object getValue() {
    return new Actions(actions);
  }

  private void showDialog() {
    ActionsPropertyPanel aPanel =
            new ActionsPropertyPanel(new Actions(actions));
    aPanel.display((JFrame) panel.getTopLevelAncestor(), this);
  }

  /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    EvolverCompileable compileable = (EvolverCompileable) bean;
    compileable.setActions((Actions)getValue());
  }

}
