package uchicago.src.simbuilder.beans;

import uchicago.src.guiUtils.CodeDocument;
import uchicago.src.nqpy.compiler.AbstractCompilerException;
import uchicago.src.simbuilder.NQPyTokenizer;
import uchicago.src.simbuilder.util.RepastPyUtilities;
import uchicago.src.simbuilder.beans.network.ActionNameDialog;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.text.DefaultEditorKit;
import javax.swing.text.Keymap;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * GUI class for Actions property editor.
 * <p/>
 * $Revision: 1.4 $ $Date: 2005/04/13 14:06:37 $
 */

// note most of the code here was generated by an gui ide tool. So
// its neither clean nor elegant.

public class ActionsPropertyPanel extends JPanel {
  
  private static final String ACTIONS_FRAME = "ACTIONS_FRAME";
  
  private static final String RET_TEXT = "Return Type:   ";
  private static final String newGif =
          "/uchicago/src/simbuilder/images/New.gif";
  private static final String saveGif =
          "/uchicago/src/simbuilder/images/Save.gif";
  private static final String delGif = "/uchicago/src/simbuilder/images/Delete.gif";
  private static final String editGif = "/uchicago/src/simbuilder/images/DocumentDraw.gif";

  BorderLayout borderLayout1 = new BorderLayout();
  JToolBar tBar = new JToolBar();
  JPanel top = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel viPanel = new JPanel();
  JPanel varsPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel importsPanel = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  JPanel sourcePanel = new JPanel();
  JPanel btnPanel = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  DragList varList = new DragList(new DefaultListModel());
  BorderLayout borderLayout4 = new BorderLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JScrollPane jScrollPane3 = new JScrollPane();
  JTextArea impEditorPane = new JTextArea();
  BorderLayout borderLayout5 = new BorderLayout();
  DragTextPane sourceEditorPane;
  JButton btnNew = new JButton();
  JButton btnDel = new JButton();
  Component component1;
  JComboBox cmbActions = new JComboBox(new DefaultComboBoxModel());
  BorderLayout borderLayout6 = new BorderLayout();
  JButton btnSave = new JButton();
  JButton btnOk = new JButton();
  JButton btnCancel = new JButton();

  JTextField fldName = new JTextField();

  private JDialog dialog;
  private ActionsPropertyEditor editor;
  private Actions actions;
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JSplitPane jSplitPane1 = new JSplitPane();
  JPanel errorPanel = new JPanel();
  JScrollPane jScrollPane4 = new JScrollPane();
  JList errorList = new JList(new DefaultListModel());
  BorderLayout borderLayout8 = new BorderLayout();
  Border border2;
  TitledBorder titledBorder2;

  private CodeDocument doc;
  private HashMap nameIndex = new HashMap();
  private int paramCount = 0;
  private int curIndex = -1;
  private boolean inNew = false;

  private JLabel retValLbl = new JLabel();
  private JButton editBtn = new JButton();

  class ErrorItem {
    AbstractCompilerException ex;
    String rep;

    public ErrorItem(AbstractCompilerException ex) {
      this.ex = ex;
      rep = ex.getMessage();
    }

    public String toString() {
      return rep;
    }
  }

  class ErrorRenderer extends JTextArea implements ListCellRenderer {

    public Component getListCellRendererComponent(JList list,
                                                  Object value,
                                                  int index,
                                                  boolean isSelected,
                                                  boolean cellHasFocus) {
      setText(value.toString());
      this.setBackground(isSelected ? Color.red : Color.white);
      this.setForeground(isSelected ? Color.white : Color.red);
      return this;
    }
  }

  public ActionsPropertyPanel(Actions actions) {
    this.actions = actions;

    try {
      jbInit();
    } catch (Exception e) {
      e.printStackTrace();
    }

    Iterator i = actions.iterator();
    int index = 0;
    DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
    while (i.hasNext()) {
      ActionCode code = (ActionCode) i.next();
      nameIndex.put(code.getName(), new Integer(index++));
      model.addElement(code);
    }

    setVarNames(actions.getVarNames());
    addListeners();
    if (model.getSize() > 0) cmbActions.setSelectedIndex(0);
    btnSave.setEnabled(model.getSize() > 0);
    btnDel.setEnabled(model.getSize() > 0);
  }

  private void setupEditorPane() {
    NQPyTokenizer t = new NQPyTokenizer();
    doc = new CodeDocument(t);
    sourceEditorPane = new DragTextPane(doc);
    Keymap map = sourceEditorPane.getKeymap();
    Hashtable acts = createActionTable(sourceEditorPane);
    KeyStroke key = KeyStroke.getKeyStroke(KeyEvent.VK_E, Event.CTRL_MASK);
    map.addActionForKeyStroke(key, (Action) acts.get(DefaultEditorKit.endLineAction));
    map.addActionForKeyStroke(KeyStroke.getKeyStroke(KeyEvent.VK_A, Event.CTRL_MASK), (Action) acts.get(DefaultEditorKit.beginLineAction));
  }

  private Hashtable createActionTable(DragTextPane txt) {
    Hashtable actions = new Hashtable();
    Action[] actionsArray = txt.getActions();
    for (int i = 0; i < actionsArray.length; i++) {
      Action a = actionsArray[i];
      actions.put(a.getValue(Action.NAME), a);
    }
    return actions;
  }


  private void jbInit() throws Exception {

    setupEditorPane();
    border1 = BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, Color.white, new Color(142, 142, 142), new Color(99, 99, 99));
    titledBorder1 = new TitledBorder(border1, "Variables");
    component1 = Box.createHorizontalStrut(8);
    border2 = BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142));
    titledBorder2 = new TitledBorder(border2, "Errors");
    this.setLayout(borderLayout1);
    this.setMaximumSize(new Dimension(55, 44));
    this.setMinimumSize(new Dimension(55, 44));
    top.setLayout(borderLayout2);
    viPanel.setLayout(borderLayout3);
    varsPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Variables"));
    varsPanel.setLayout(borderLayout6);
    importsPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Java Imports"));
    importsPanel.setLayout(borderLayout4);
    sourcePanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Source"));
    sourcePanel.setLayout(borderLayout5);

    btnNew.setRequestFocusEnabled(false);
    btnNew.setToolTipText("New Action");
    btnNew.setIcon(new ImageIcon(this.getClass().getResource(newGif)));
    btnSave.setIcon(new ImageIcon(this.getClass().getResource(saveGif)));
    btnSave.setToolTipText("Save Action");
    btnDel.setRequestFocusEnabled(false);
    btnDel.setToolTipText("Delete Action");
    btnDel.setIcon(new ImageIcon(this.getClass().getResource(delGif)));

    editBtn.setIcon(new ImageIcon(this.getClass().getResource(editGif)));
    editBtn.setToolTipText("Edit Action Signature");

    cmbActions.setMaximumSize(new Dimension(150, 31));
    cmbActions.setMinimumSize(new Dimension(150, 31));
    cmbActions.setPreferredSize(new Dimension(150, 31));

    fldName.setMaximumSize(new Dimension(150, 31));
    fldName.setMinimumSize(new Dimension(150, 31));
    fldName.setPreferredSize(new Dimension(150, 31));

    btnOk.setText("OK");
    btnCancel.setText("Cancel");
    sourceEditorPane.setFont(new java.awt.Font("Monospaced", 0, 12));
    btnPanel.setLayout(borderLayout7);
    jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setDividerSize(4);
    errorPanel.setLayout(borderLayout8);
    errorPanel.setBorder(titledBorder2);
    this.add(top, BorderLayout.NORTH);
    top.add(tBar, BorderLayout.NORTH);
    tBar.add(btnNew, null);
    tBar.add(editBtn);
    tBar.add(btnSave, null);
    tBar.add(btnDel, null);
    tBar.add(component1, null);
    tBar.add(cmbActions, null);
    retValLbl.setText(RET_TEXT);
    tBar.add(Box.createHorizontalStrut(10));
    tBar.add(retValLbl);
    top.add(viPanel, BorderLayout.CENTER);
    viPanel.add(varsPanel, BorderLayout.WEST);
    jScrollPane1 = new JScrollPane(varList);
    varsPanel.add(jScrollPane1, BorderLayout.CENTER);
    viPanel.add(importsPanel, BorderLayout.CENTER);
    importsPanel.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(impEditorPane, null);
    this.add(btnPanel, BorderLayout.SOUTH);
    btnPanel.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(btnOk, null);
    jPanel1.add(btnCancel, null);
    this.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(sourcePanel, JSplitPane.LEFT);
    sourcePanel.add(jScrollPane3, BorderLayout.CENTER);
    jSplitPane1.add(errorPanel, JSplitPane.RIGHT);
    jScrollPane3.getViewport().add(sourceEditorPane, null);
    errorPanel.add(jScrollPane4, BorderLayout.CENTER);
    jScrollPane4.getViewport().add(errorList, null);

    errorList.setCellRenderer(new ErrorRenderer());
    varList.setVisibleRowCount(4);


  }

  public void addToToolBar(JPanel p) {
    tBar.addSeparator();
    tBar.add(p);
  }

  public void addListeners() {
    btnNew.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        doNew();
      }
    });

    editBtn.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        doEdit();
      }
    });

    fldName.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent evt) {
        //postNew();
      }
    });

    fldName.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        sourceEditorPane.requestFocus();
      }
    });

    btnOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RepastPyUtilities.savePreferredWindowBounds(ACTIONS_FRAME, dialog.getBounds());
        if (dialog != null) dialog.dispose();
        doSave();
        editor.setValue(getActions());
        editor.firePropertyChange();
      }
    });

    btnCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        RepastPyUtilities.savePreferredWindowBounds(ACTIONS_FRAME, dialog.getBounds());
        if (dialog != null) dialog.dispose();
      }
    });

    cmbActions.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (!inNew) doSave();
        curIndex = cmbActions.getSelectedIndex();
        if (curIndex != -1) {
          editBtn.setEnabled(true);
          ActionCode code = (ActionCode) cmbActions.getItemAt(curIndex);
          ArrayList imports = code.getImports();
          StringBuffer b = new StringBuffer();
          for (int i = 0; i < imports.size(); i++) {
            String imp = (String) imports.get(i);
            if (i != 0) b.append("\n");
            b.append(imp);
          }

          impEditorPane.setText(b.toString());

          DefaultListModel lm = (DefaultListModel) varList.getModel();
          if (paramCount != 0) {
            //System.out.println("param count: " + paramCount);
            //System.out.println("lm size: " + lm.size());
            lm.removeRange(lm.size() - paramCount, lm.size() - 1);
          }

          ArrayList params = code.getParameterNames();
          paramCount = params.size();
          for (int i = 0; i < paramCount; i++) {
            String pName = (String) params.get(i);
            //System.out.println("adding element: " + pName);

            lm.addElement(pName);
          }

          sourceEditorPane.setText(code.getCode());
          if (code.getRetType().equals("void")) {
            retValLbl.setText(RET_TEXT + "None");
          } else {
            retValLbl.setText(RET_TEXT + code.getRetType());
          }
        } else {
          editBtn.setEnabled(false);
          sourceEditorPane.setText("");
        }
      }
    });

    btnSave.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        //if (inNew) postNew();
        doSave();
      }
    });

    btnDel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        boolean isBlank = inNew && fldName.getText().trim().length() == 0;
        //if (inNew) postNew();
        if (curIndex != -1 && !isBlank) {
          ActionCode codeToDelete = (ActionCode) cmbActions.getItemAt(curIndex);
          int retVal = JOptionPane.showConfirmDialog(ActionsPropertyPanel.this, "Delete '" + codeToDelete.getName() + 
                  "' action ?", "Delete Action", JOptionPane.YES_NO_OPTION);
          if (retVal == JOptionPane.OK_OPTION) {
            actions.remove(codeToDelete.getName());
            cmbActions.removeItemAt(curIndex);
            curIndex = cmbActions.getSelectedIndex();
          }
        }

        btnSave.setEnabled(cmbActions.getModel().getSize() > 0);
        btnDel.setEnabled(cmbActions.getModel().getSize() > 0);
      }
    });

    errorList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // getClickCount always returns 1. So this will never be
        // called.
        if (evt.getClickCount() == 2) {
          int index = errorList.locationToIndex(evt.getPoint());
          if (index >= 0) {
            ErrorItem item = (ErrorItem)
                    (errorList.getModel()).getElementAt(index);
            goToError(item);
          }
        }
      }
    });

    errorList.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // enter key returns VK_UNDEFINED rather than
        // VK_ENTER so check for char instead.
        if (evt.getKeyChar() == '\n') {
          int index = errorList.getSelectedIndex();
          if (index >= 0) {
            ErrorItem item = (ErrorItem)
                    (errorList.getModel()).getElementAt(index);
            goToError(item);
          }
        }
      }
    });

    varList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // getClickCount always returns 1. So this will never be
        // called.
        if (evt.getClickCount() == 2) {
          Object o = varList.getSelectedValue();
          if (o != null) {
            insertVar(o.toString());
          }
        }
      }
    });

    varList.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // enter key returns VK_UNDEFINED rather than
        // VK_ENTER so check for char instead.
        if (evt.getKeyChar() == '\n') {
          Object o = varList.getSelectedValue();
          if (o != null) {
            insertVar(o.toString());
          }
        }
      }
    });
  }

  private void doEdit() {
    if (curIndex != -1) {
      ActionCode code = (ActionCode) cmbActions.getItemAt(curIndex);
      ActionNameDialog dialog = new ActionNameDialog(code.getName(), code.getRetType());
      boolean edit = dialog.display(this.dialog);
      if (edit) {
        code.setName(dialog.getName());
        code.setRetType(dialog.getReturnType());
        retValLbl.setText(RET_TEXT + dialog.getReturnType());
        cmbActions.invalidate();
        cmbActions.validate();
        cmbActions.repaint();
      }
    }
  }

  private void doNew() {
    doSave();
    inNew = true;
    ActionNameDialog dialog = new ActionNameDialog("", "");
    boolean makeNew = dialog.display(this.dialog);
    if (makeNew) {
      if (dialog.getName().length() > 0) {
        DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
        ActionCode code = new ActionCode(dialog.getName());
        code.setRetType(dialog.getReturnType());
        model.addElement(code);
        curIndex = model.getSize() - 1;
        sourceEditorPane.setText("");
        sourceEditorPane.requestFocus();
      }

      cmbActions.setSelectedIndex(curIndex);
      inNew = false;
    }

    btnSave.setEnabled(cmbActions.getModel().getSize() > 0);
    btnDel.setEnabled(cmbActions.getModel().getSize() > 0);
  }

  /*
  private void postNew() {
    if (inNew) {
      btnNew.setEnabled(true);
      tBar.remove(fldName);
      tBar.add(cmbActions);
      tBar.invalidate();
      tBar.revalidate();
      tBar.repaint();

      if (fldName.getText().trim().length() > 0) {
        DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
        ActionCode code = new ActionCode(fldName.getText());
        model.addElement(code);
        curIndex = model.getSize() - 1;
        fldName.setText("");
        sourceEditorPane.setText("");
      }

      cmbActions.setSelectedIndex(curIndex);
      inNew = false;
    }
  }
  */

  private void goToError(ErrorItem item) {
    int lineNum = item.ex.getLineNum();
    int pos = 0;
    if (lineNum > 0) pos = doc.highlightError(lineNum);
    sourceEditorPane.setCaretPosition(pos);
    sourceEditorPane.requestFocus();
  }

  private void insertVar(String var) {
    int pos = sourceEditorPane.getCaretPosition();
    sourceEditorPane.replaceSelection(var);
    sourceEditorPane.setCaretPosition(pos + var.length());
    sourceEditorPane.requestFocus();
  }

  private void doSave() {
    if (curIndex != -1) {
      ActionCode code = (ActionCode) cmbActions.getItemAt(curIndex);
      code.setCode(sourceEditorPane.getText());
      String imps = impEditorPane.getText().trim();
      ArrayList l = new ArrayList();
      if (imps.length() != 0) {
        StringTokenizer t = new StringTokenizer(imps);
        while (t.hasMoreTokens()) {
          l.add(t.nextToken());
        }
      }
      code.setImports(l);
      nameIndex.put(code.getName(), new Integer(curIndex));
    }
  }

  public Actions getActions() {
    actions.clear();
    DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
    //System.out.println("model size: " + model.getSize());
    for (int i = 0; i < model.getSize(); i++) {
      actions.addAction((ActionCode) model.getElementAt(i));
    }

    return actions;
  }

  public void addError(AbstractCompilerException ex) {
    ((DefaultListModel) errorList.getModel()).add(0, new ErrorItem(ex));
    String block = ex.getBlockName();
    String method = block.substring(block.lastIndexOf(".") + 1, block.length());
    int index = ((Integer) nameIndex.get(method)).intValue();
    cmbActions.setSelectedIndex(index);
  }

  public void setVarNames(ArrayList names) {
    //System.out.println("setting varNames");

    String self = "self.";
    DefaultListModel model = (DefaultListModel) varList.getModel();
    model.clear();
    int size = names.size();
    for (int i = 0; i < size; i++) {
      model.addElement(self + names.get(i));
    }
  }

  public void display(JFrame f, ActionsPropertyEditor editor) {
    this.editor = editor;
    dialog = new JDialog(f, false);
    
    dialog.setTitle("Actions Editor");
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.getContentPane().add(this, BorderLayout.CENTER);
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        RepastPyUtilities.savePreferredWindowBounds(ACTIONS_FRAME, dialog.getBounds());
        dialog.dispose();
      }
    });

    if ((errorList.getModel()).getSize() > 0) {
      jSplitPane1.setDividerLocation(220);
      dialog.pack();
      Rectangle bounds = RepastPyUtilities.getPreferredWindowBounds(ACTIONS_FRAME, 650, 550);
      dialog.setBounds(bounds);
      errorList.setVisibleRowCount(4);

    } else {
      errorPanel.setVisible(false);
      dialog.pack();
      Rectangle bounds = RepastPyUtilities.getPreferredWindowBounds(ACTIONS_FRAME, 650, 550);
      dialog.setBounds(bounds);
    }

    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }
}
