package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.util.BooleanMessage;

/**
 * @author Nick Collier
 * @version $Revision: 1.3 $ $Date: 2004/12/14 22:10:48 $
 */
public interface AgentProducer extends EvolverCompileable {
  public String getNQPyInit();

  public String getNQPySetup();

  public String getGroupName();

  public BooleanMessage isValid();
  
  public void addPossibleParentClass(AgentProducer producer);
  
  public void updatePossibleParent(AgentProducer producer, String newName);

  public void removePossibleParentClass(AgentProducer producer);

  /**
   * We can't set the superclass while loading because the produce may not know about
   * all the other producers yet. So, we need a separate method to call after all have been
   * loaded.
   */
  public void setInitialSuperClass();
  
  /**
   * Returns true if this AgentProducer is the parent class of another AgentProducer.
   * @return
   */ 
  public boolean isParent();
  
  /**
   * Sets whether or not this AgentProducer is the "parent" of another agent producer.
   * @param isParent
   */ 
  public void setIsParent(boolean isParent);
  
  /**
   * Returns the AgentProducer that is the "parent" of this AgentProducer. May return null;
   * @return
   */ 
  public AgentProducer getParent();
  
}
