package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ColorPropertyEditor extends EvolverPropertyEditor {

  private JButton b = new JButton();
  private Color color;

  public ColorPropertyEditor() {
    Dimension d = new Dimension(16, 16);
    b.setPreferredSize(d);
    b.setMinimumSize(d);
    b.setMaximumSize(d);

    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new FlowLayout(FlowLayout.CENTER, 0, 2));
//panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
//panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        Color c = JColorChooser.showDialog(panel,
                "Background Color",
                color);
        if (c != null) {
          setValue(c);
          firePropertyChange();
        }
      }
    });
  }

  public void setValue(Object val) {
    Color c = (Color) val;
    color = new Color(c.getRed(), c.getGreen(), c.getBlue());
    b.setBackground(color);
  }

  public Object getValue() {
    return new Color(color.getRed(), color.getGreen(), color.getBlue());
  }

}



