package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Editor for constrained properties displayed in a combobox.
 */

public class ConstrainedPropertyEditor extends EvolverPropertyEditor {

  private JComboBox comboBox;
  private boolean init = false;
  private ConstrainedProperty prop;
  private int index;

  public ConstrainedPropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    comboBox = new JComboBox();
    panel.add(comboBox);


    comboBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (prop != null) {
          index = comboBox.getSelectedIndex();
          firePropertyChange();

        }
      }
    });
  }

  public void setValue(Object val) {
    super.setValue(val);
    prop = new ConstrainedProperty((ConstrainedProperty) val);
    if (!init) {
      comboBox.removeAllItems();
      Object[] views = prop.getViews();
      for (int i = 0; i < views.length; i++) {
        comboBox.addItem(views[i]);
      }

      init = true;
    }

    comboBox.setSelectedIndex(prop.getSelectedIndex());
  }

  public void reInit() {
    init = false;
  }

  public Object getValue() {
    ConstrainedProperty p = new ConstrainedProperty(prop);
    p.setSelected(index);
    return p;
  }
}
