package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:25 $
 */
public class DSActionsEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private JLabel label = EvolverPropertyEditor.getLabel();
  private DataSourceActions actions = new DataSourceActions();

  public DSActionsEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Data Sources");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    actions = new DataSourceActions((DataSourceActions) val);
    label.setText(actions.size() + " Data Source(s)");
  }

  public Object getValue() {
    return new DataSourceActions(actions);
  }

  private void showDialog() {
    DSActionsEditorPanel aPanel =
            new DSActionsEditorPanel(new DataSourceActions(actions));
    aPanel.display((JFrame) panel.getTopLevelAncestor(), this);
  }

  /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    DataRecorder recorder = (DataRecorder)bean;
    recorder.setDataSources((DataSourceActions) getValue());
  }

}
