package uchicago.src.simbuilder.beans;

import uchicago.src.guiUtils.CodeDocument;
import uchicago.src.nqpy.compiler.AbstractCompilerException;
import uchicago.src.simbuilder.NQPyTokenizer;
import uchicago.src.simbuilder.beans.network.ActionNameDialog;
import uchicago.src.simbuilder.property.IntegerDocument;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.StringTokenizer;

/**
 * Bad cut and paste job from ActionsPropertyPanel.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
public class DSActionsEditorPanel extends JPanel {

  private static final String newGif =
          "/uchicago/src/simbuilder/images/New.gif";
  private static final String saveGif =
          "/uchicago/src/simbuilder/images/Save.gif";
  private static final String delGif =
          "/uchicago/src/simbuilder/images/Delete.gif";

  BorderLayout borderLayout1 = new BorderLayout();
  JToolBar tBar = new JToolBar();
  JPanel top = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel viPanel = new JPanel();
  JPanel varsPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel importsPanel = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  JPanel sourcePanel = new JPanel();
  JPanel btnPanel = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  DragList varList = new DragList(new DefaultListModel());
  BorderLayout borderLayout4 = new BorderLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JScrollPane jScrollPane3 = new JScrollPane();
  JTextArea impEditorPane = new JTextArea();
  BorderLayout borderLayout5 = new BorderLayout();
  DragTextPane sourceEditorPane;
  JButton btnNew = new JButton();
  JButton btnDel = new JButton();
  Component component1;
  JComboBox cmbActions = new JComboBox(new DefaultComboBoxModel());
  BorderLayout borderLayout6 = new BorderLayout();
  JButton btnSave = new JButton();
  JButton btnOk = new JButton();
  JButton btnCancel = new JButton();

  JTextField fldName = new JTextField();

  JCheckBox boxNum = new JCheckBox("Numeric");
  JCheckBox boxObj = new JCheckBox("Object");
  JTextField fldMaxInt = new JTextField(new IntegerDocument(), "", 4);
  JTextField fldMaxFrac = new JTextField(new IntegerDocument(), "", 4);
  JLabel lblMaxInt = new JLabel("Max. Integer Digits");
  JLabel lblMaxFrac = new JLabel("Max. Fractional Digits");


  private JDialog dialog;
  private DSActionsEditor editor;
  private DataSourceActions actions;
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JSplitPane jSplitPane1 = new JSplitPane();
  JPanel errorPanel = new JPanel();
  JScrollPane jScrollPane4 = new JScrollPane();
  JList errorList = new JList(new DefaultListModel());
  BorderLayout borderLayout8 = new BorderLayout();
  Border border2;
  TitledBorder titledBorder2;

  private CodeDocument doc;
  private HashMap nameIndex = new HashMap();
  private int paramCount = 0;
  private int curIndex = -1;

  class ErrorItem {
    AbstractCompilerException ex;
    String rep;

    public ErrorItem(AbstractCompilerException ex) {
      this.ex = ex;
      rep = ViolinStrings.Strings.change(ex.getMessage(), "self", "self.model");

    }

    public String toString() {
      return rep;
    }
  }

  class ErrorRenderer extends JTextArea implements ListCellRenderer {

    public Component getListCellRendererComponent(JList list,
                                                  Object value,
                                                  int index,
                                                  boolean isSelected,
                                                  boolean cellHasFocus) {
      setText(value.toString());
      this.setBackground(isSelected ? Color.red : Color.white);
      this.setForeground(isSelected ? Color.white : Color.red);
      return this;
    }
  }

  public DSActionsEditorPanel(DataSourceActions actions) {
    this.actions = actions;

    try {
      jbInit();
    } catch (Exception e) {
      e.printStackTrace();
    }

    Iterator i = actions.iterator();
    int index = 0;
    DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
    while (i.hasNext()) {
      DataSourceActionCode code = (DataSourceActionCode) i.next();
      nameIndex.put(code.getName(), new Integer(index++));
      model.addElement(code);
    }

    setVarNames(actions.getVarNames());
    addListeners();
    if (model.getSize() > 0) cmbActions.setSelectedIndex(0);
    btnSave.setEnabled(model.getSize() > 0);
    btnDel.setEnabled(model.getSize() > 0);
  }

  private void setupEditorPane() {
    NQPyTokenizer t = new NQPyTokenizer();
    doc = new CodeDocument(t);
    sourceEditorPane = new DragTextPane(doc);
  }

  private void jbInit() throws Exception {

    setupEditorPane();
    border1 = BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, Color.white, new Color(142, 142, 142), new Color(99, 99, 99));
    titledBorder1 = new TitledBorder(border1, "Variables");
    component1 = Box.createHorizontalStrut(8);
    border2 = BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142));
    titledBorder2 = new TitledBorder(border2, "Errors");
    this.setLayout(borderLayout1);
    //this.setMaximumSize(new Dimension(55, 44));
    //this.setMinimumSize(new Dimension(55, 44));
    top.setLayout(borderLayout2);
    viPanel.setLayout(borderLayout3);
    varsPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Variables"));
    varsPanel.setLayout(borderLayout6);
    importsPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Java Imports"));
    importsPanel.setLayout(borderLayout4);
    sourcePanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Source"));
    sourcePanel.setLayout(borderLayout5);
    btnNew.setRequestFocusEnabled(false);
    btnNew.setToolTipText("New Data Source");
    btnNew.setIcon(new ImageIcon(this.getClass().getResource(newGif)));
    btnSave.setIcon(new ImageIcon(this.getClass().getResource(saveGif)));
    btnSave.setToolTipText("Save Data Source");
    btnDel.setRequestFocusEnabled(false);
    btnDel.setToolTipText("Delete Data Source");
    btnDel.setIcon(new ImageIcon(this.getClass().getResource(delGif)));

    cmbActions.setMaximumSize(new Dimension(150, 31));
    cmbActions.setMinimumSize(new Dimension(150, 31));
    cmbActions.setPreferredSize(new Dimension(150, 31));

    //fldName.setMaximumSize(new Dimension(150, 31));
    //fldName.setMinimumSize(new Dimension(150, 31));
    //fldName.setPreferredSize(new Dimension(150, 31));

    btnOk.setText("OK");
    btnCancel.setText("Cancel");
    sourceEditorPane.setFont(new java.awt.Font("Monospaced", 0, 12));
    btnPanel.setLayout(borderLayout7);
    jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setDividerSize(4);
    errorPanel.setLayout(borderLayout8);
    errorPanel.setBorder(titledBorder2);
    this.add(top, BorderLayout.NORTH);
    top.add(tBar, BorderLayout.NORTH);

    tBar.add(btnNew, null);
    tBar.add(btnSave, null);
    tBar.add(btnDel);
    tBar.add(component1, null);
    tBar.add(cmbActions, null);
    top.add(viPanel, BorderLayout.SOUTH);
    viPanel.add(varsPanel, BorderLayout.WEST);
    jScrollPane1 = new JScrollPane(varList);
    varsPanel.add(jScrollPane1, BorderLayout.CENTER);
    viPanel.add(importsPanel, BorderLayout.CENTER);
    importsPanel.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(impEditorPane, null);
    this.add(btnPanel, BorderLayout.SOUTH);
    btnPanel.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(btnOk, null);
    jPanel1.add(btnCancel, null);
    this.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(sourcePanel, JSplitPane.LEFT);
    sourcePanel.add(jScrollPane3, BorderLayout.CENTER);
    jSplitPane1.add(errorPanel, JSplitPane.RIGHT);
    jScrollPane3.getViewport().add(sourceEditorPane, null);
    errorPanel.add(jScrollPane4, BorderLayout.CENTER);
    jScrollPane4.getViewport().add(errorList, null);

    errorList.setCellRenderer(new DSActionsEditorPanel.ErrorRenderer());
    varList.setVisibleRowCount(4);

    JPanel p = new JPanel(new GridLayout(2, 3));
    p.setBorder(BorderFactory.createEtchedBorder());
    p.add(boxNum);
    p.add(lblMaxInt);
    p.add(fldMaxInt);
    p.add(boxObj);
    p.add(lblMaxFrac);
    p.add(fldMaxFrac);

    ButtonGroup g = new ButtonGroup();
    g.add(boxNum);
    g.add(boxObj);
    boxNum.setSelected(true);
    top.add(p, BorderLayout.CENTER);

  }

  public void addToToolBar(JPanel p) {
    tBar.addSeparator();
    tBar.add(p);
  }

  public void addListeners() {
    btnNew.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        doNew();
      }
    });

    btnDel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (curIndex != -1) {
          DataSourceActionCode codeToDelete = (DataSourceActionCode) cmbActions.getItemAt(curIndex);
          int retVal = JOptionPane.showConfirmDialog(DSActionsEditorPanel.this, "Delete '" + codeToDelete.getName() +
                  "' data source ?", "Delete DataSource", JOptionPane.YES_NO_OPTION);
          if (retVal == JOptionPane.OK_OPTION) {
            actions.remove(codeToDelete.getName());
            cmbActions.removeItemAt(curIndex);
            curIndex = cmbActions.getSelectedIndex();
          }
        }

        btnSave.setEnabled(cmbActions.getModel().getSize() > 0);
        btnDel.setEnabled(cmbActions.getModel().getSize() > 0);
      }
    });

    btnOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) dialog.dispose();
        doSave();
        editor.setValue(getActions());
        editor.firePropertyChange();
      }
    });

    btnCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (dialog != null) dialog.dispose();
      }
    });

    cmbActions.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        doSave();
        curIndex = cmbActions.getSelectedIndex();
        if (curIndex != -1) {
          DataSourceActionCode code = (DataSourceActionCode) cmbActions.getItemAt(curIndex);
          ArrayList imports = code.getImports();
          StringBuffer b = new StringBuffer();
          for (int i = 0; i < imports.size(); i++) {
            String imp = (String) imports.get(i);
            if (i != 0) b.append("\n");
            b.append(imp);
          }

          impEditorPane.setText(b.toString());

          DefaultListModel lm = (DefaultListModel) varList.getModel();
          if (paramCount != 0) {
            //System.out.println("param count: " + paramCount);
            //System.out.println("lm size: " + lm.size());
            lm.removeRange(lm.size() - paramCount, lm.size() - 1);
          }

          ArrayList params = code.getParameterNames();
          paramCount = params.size();
          for (int i = 0; i < paramCount; i++) {
            String pName = (String) params.get(i);
            lm.addElement(pName);
          }

          sourceEditorPane.setText(code.getCode());
          if (code.isNumeric()) {
            enableFracFields(true);
            boxNum.setSelected(true);
            fldMaxFrac.setText(String.valueOf(code.getMaxFracDigits()));
            fldMaxInt.setText(String.valueOf(code.getMaxIntDigits()));
          } else {
            fldMaxFrac.setText("");
            fldMaxInt.setText("");
            enableFracFields(false);
            boxObj.setSelected(true);
          }
        } else {
          sourceEditorPane.setText("");
        }
      }
    });

    btnSave.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        doSave();
      }
    });

    boxObj.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        enableFracFields(false);
        fldMaxInt.setText("");
        fldMaxFrac.setText("");

      }
    });

    boxNum.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        enableFracFields(true);
      }
    });

    errorList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // getClickCount always returns 1. So this will never be
        // called.
        if (evt.getClickCount() == 2) {
          int index = errorList.locationToIndex(evt.getPoint());
          if (index >= 0) {
            DSActionsEditorPanel.ErrorItem item = (DSActionsEditorPanel.ErrorItem)
                    errorList.getModel().getElementAt(index);
            goToError(item);
          }
        }
      }
    });

    errorList.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // enter key returns VK_UNDEFINED rather than
        // VK_ENTER so check for char instead.
        if (evt.getKeyChar() == '\n') {
          int index = errorList.getSelectedIndex();
          if (index >= 0) {
            DSActionsEditorPanel.ErrorItem item = (DSActionsEditorPanel.ErrorItem)
                    errorList.getModel().getElementAt(index);
            goToError(item);
          }
        }
      }
    });

    varList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // getClickCount always returns 1. So this will never be
        // called.
        if (evt.getClickCount() == 2) {
          Object o = varList.getSelectedValue();
          if (o != null) {
            insertVar(o.toString());
          }
        }
      }
    });

    varList.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // enter key returns VK_UNDEFINED rather than
        // VK_ENTER so check for char instead.
        if (evt.getKeyChar() == '\n') {
          Object o = varList.getSelectedValue();
          if (o != null) {
            insertVar(o.toString());
          }
        }
      }
    });
  }

  private void enableFracFields(boolean val) {
    fldMaxInt.setEnabled(val);
    lblMaxInt.setEnabled(val);
    fldMaxFrac.setEnabled(val);
    lblMaxFrac.setEnabled(val);
  }

  private void goToError(DSActionsEditorPanel.ErrorItem item) {
    int lineNum = item.ex.getLineNum();
    int pos = doc.highlightError(lineNum);
    sourceEditorPane.setCaretPosition(pos);
    sourceEditorPane.requestFocus();
  }

  private void insertVar(String var) {
    int pos = sourceEditorPane.getCaretPosition();
    sourceEditorPane.replaceSelection(var);
    sourceEditorPane.setCaretPosition(pos + var.length());
    sourceEditorPane.requestFocus();
  }

  private int parseFracFields(JTextField fld) {
    int val = 0;
    if (fld.getText().trim().length() == 0) return -1;
    try {
      val = Integer.parseInt(fld.getText().trim());
      if (val < 0) val = -1;
    } catch (NumberFormatException ex) {
      // we should never get here as the flds have IntegerDocuments
      ex.printStackTrace();
    }

    return val;
  }

  private void doNew() {
    doSave();
    ActionNameDialog dialog = new ActionNameDialog("", "", false);
    boolean makeNew = dialog.display(this.dialog, "Data Source Name");
    if (makeNew) {
      if (dialog.getName().length() > 0) {
        DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
        DataSourceActionCode code = new DataSourceActionCode(dialog.getName());
        model.addElement(code);
        curIndex = model.getSize() - 1;
        sourceEditorPane.setText("");
        sourceEditorPane.requestFocus();
      }

      cmbActions.setSelectedIndex(curIndex);
    }

    btnSave.setEnabled(cmbActions.getModel().getSize() > 0);
    btnDel.setEnabled(cmbActions.getModel().getSize() > 0);
  }

  private void doSave() {
    if (curIndex != -1) {
      DataSourceActionCode code = (DataSourceActionCode) cmbActions.getItemAt(curIndex);
      code.setCode(sourceEditorPane.getText());
      if (boxNum.isSelected()) {
        code.setType(DataSourceActionCode.NUMERIC);
        code.setMaxFracDigits(parseFracFields(fldMaxFrac));
        code.setMaxIntDigits(parseFracFields(fldMaxInt));
      } else {
        code.setType(DataSourceActionCode.OBJECT);
      }

      String imps = impEditorPane.getText().trim();
      if (imps.length() != 0) {
        ArrayList l = new ArrayList();
        StringTokenizer t = new StringTokenizer(imps);
        while (t.hasMoreTokens()) {
          l.add(t.nextToken());
        }

        code.setImports(l);
      }

      nameIndex.put(code.getName(), new Integer(curIndex));
    }
  }

  public DataSourceActions getActions() {
    actions.clear();
    DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
    //System.out.println("model size: " + model.getSize());
    for (int i = 0; i < model.getSize(); i++) {
      actions.addDataSource((DataSourceActionCode) model.getElementAt(i));
    }

    return actions;
  }

  public void addError(AbstractCompilerException ex) {
    ((DefaultListModel) errorList.getModel()).add(0, new DSActionsEditorPanel.ErrorItem(ex));
    String block = ex.getBlockName();
    String method = block.substring(block.lastIndexOf(".") + 1, block.length());
    int index = ((Integer) nameIndex.get(method)).intValue();
    cmbActions.setSelectedIndex(index);
  }

  public void setVarNames(ArrayList names) {
    //System.out.println("setting varNames");

    String self = "self.";
    DefaultListModel model = (DefaultListModel) varList.getModel();
    model.clear();
    int size = names.size();
    for (int i = 0; i < size; i++) {
      model.addElement(self + (String) names.get(i));
    }
  }

  public void display(JFrame f, DSActionsEditor editor) {
    this.editor = editor;
    dialog = new JDialog(f, false);
    dialog.setTitle("Data Source Editor");
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.getContentPane().add(this, BorderLayout.CENTER);
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        dialog.dispose();
      }
    });

    if ((errorList.getModel()).getSize() > 0) {
      jSplitPane1.setDividerLocation(220);
      dialog.pack();
      dialog.setSize(650, 550);
      errorList.setVisibleRowCount(4);

    } else {
      errorPanel.setVisible(false);
      dialog.pack();
      dialog.setSize(650, 450);
    }

    /*
    Dimension d = new Dimension(32, 32);
    btnDel.setSize(d);
    btnDel.setPreferredSize(d);
    btnDel.setMaximumSize(d);
    btnDel.setMinimumSize(d);
    */

    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }
}
