package uchicago.src.simbuilder.beans;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;

/**
 * Container for DataSourceActionCode objects.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:25 $
 */
public class DataSourceActions {

  private ArrayList actions = new ArrayList();
  private ArrayList varNames = new ArrayList();

  public DataSourceActions() {
  }

  /**
   * A copy constructor.
   */
  public DataSourceActions(DataSourceActions dsa) {
    for (int i = 0, n = dsa.actions.size(); i < n; i++) {
      DataSourceActionCode code = (DataSourceActionCode) dsa.actions.get(i);
      actions.add(code.copy());
    }

    varNames.addAll(dsa.varNames);
  }

  public void addDataSource(DataSourceActionCode code) {
    actions.add(code);
  }

  public Object remove(int index) {
    return actions.remove(index);
  }

  public Object remove(String name) {
    for (int i = 0; i < actions.size(); i++) {
      ActionCode c = (ActionCode) actions.get(i);
      if (c.getName().equals(name)) {
        actions.remove(i);
        return c;
      }
    }

    return null;
  }

  public int size() {
    return actions.size();
  }

  public Iterator iterator() {
    return actions.iterator();
  }

  public void clearVarNames() {
    varNames.clear();
  }

  public void addVarName(String name) {
    varNames.add(name);
  }

  public ArrayList getVarNames() {
    Collections.sort(varNames);
    return varNames;
  }

  public void clear() {
    actions.clear();
  }

  public String toXML() {
    StringBuffer b = new StringBuffer();
    for (int i = 0; i < actions.size(); i++) {
      DataSourceActionCode code = (DataSourceActionCode) actions.get(i);
      b.append("  ");
      b.append(code.toXML());
      b.append("\n");
    }
    return b.toString();
  }
}
