package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Bean editor for Description classes.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:25 $
 */
public class DescriptionEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private Description description = new Description();

  public DescriptionEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit / View Description");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    description = new Description((Description) val);
  }

  public Object getValue() {
    return new Description(description);
  }

  private void showDialog() {
    DescriptionEditorPanel aPanel = new DescriptionEditorPanel(description);
    aPanel.display((JFrame) panel.getTopLevelAncestor(), this);
  }
}
