package uchicago.src.simbuilder.beans;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 * Gui editor for editing descriptions.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:25 $
 */

public class DescriptionEditorPanel extends JPanel {

  private JTextArea area = new JTextArea(20, 60);
  private JDialog dialog;
  private DescriptionEditor editor;

  public DescriptionEditorPanel(Description d) {
    setLayout(new BorderLayout());
    area.setWrapStyleWord(true);
    area.setLineWrap(true);
    area.setText(d.getText());
    JScrollPane p = new JScrollPane(area);
    add(p, BorderLayout.CENTER);
    JPanel buttons = new JPanel();
    add(buttons, BorderLayout.SOUTH);
    JButton ok = new JButton("OK");
    JButton cancel = new JButton("Cancel");
    buttons.add(ok);
    buttons.add(cancel);

    ok.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) dialog.dispose();
        editor.setValue(new Description(area.getText()));
        editor.firePropertyChange();
      }
    });

    cancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (dialog != null) dialog.dispose();
      }
    });
  }

  public void display(JFrame f, DescriptionEditor editor) {
    this.editor = editor;
    dialog = new JDialog(f, false);
    dialog.setTitle("Description Editor");
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.getContentPane().add(this, BorderLayout.CENTER);
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        dialog.dispose();
      }
    });

    dialog.pack();
    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }

}
