package uchicago.src.simbuilder.beans;

import javax.swing.*;
import javax.swing.text.BadLocationException;
import javax.swing.text.StyledDocument;
import java.awt.*;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.*;
import java.io.IOException;

/**
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:25 $
 */

class DragTextPane extends JTextPane implements DropTargetListener {

  public DragTextPane(StyledDocument d) {
    super(d);
    new DropTarget(this, DnDConstants.ACTION_COPY_OR_MOVE, this);

  }

  // its necessary to override this so that auto wordwrap is turned off.
  // normally this always returns true.
  public boolean getScrollableTracksViewportWidth() {
    return (getSize().width < getParent().getSize().width);
  }

  public void setSize(Dimension d) {
    if (d.width < getParent().getSize().width) {
      d.width = getParent().getSize().width;
    }

    super.setSize(d);
  }

  public void drop(DropTargetDropEvent e) {
    try {
      Transferable tr = e.getTransferable();
      if (e.isDataFlavorSupported(DataFlavor.stringFlavor)) {
        String txt = (String) tr.getTransferData(DataFlavor.stringFlavor);
        e.acceptDrop(DnDConstants.ACTION_COPY_OR_MOVE);
        int pos = viewToModel(e.getLocation());
        getDocument().insertString(pos, txt, null);
        requestFocus();
        e.dropComplete(true);
      } else {
        e.rejectDrop();
      }
    } catch (IOException ioe) {
      ioe.printStackTrace();
    } catch (UnsupportedFlavorException ufe) {
      ufe.printStackTrace();
    } catch (BadLocationException ex) {
      ex.printStackTrace();
    }
  }

  public void dragEnter(DropTargetDragEvent e) {
  }

  public void dragExit(DropTargetEvent e) {
  }

  public void dragOver(DropTargetDragEvent e) {
  }

  public void dropActionChanged(DropTargetDragEvent e) {
  }

}
