package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Property editor for EvSchedule objects. The EvSchedule is displayed
 * and edited in an EvScheduleEditorPanel.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
public class EvScheduleEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private EvScheduleEditorPanel evpanel;
  private EvSchedule schedule;

  public EvScheduleEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Schedule");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    schedule = (EvSchedule) val; //.copy();
    //System.out.println("SET VALUE SCHEDULE: " + schedule);
  }

  public Object getValue() {
    //EvSchedule copy = schedule.copy();
    //System.out.println("GET VALUE SCHEDULE: " + copy);
    //return copy;
    return schedule;
  }

  public void showDialog() {
    EvSchedule copy = schedule.copy();
    copy.processEvolverBeans();
    evpanel = new EvScheduleEditorPanel(copy);
    evpanel.display((JFrame) panel.getTopLevelAncestor(), this);
  }
  
  /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    AbstractEvolverModel model = (AbstractEvolverModel) bean;
    model.setMasterSchedule((EvSchedule) getValue());
  }
}
