package uchicago.src.simbuilder.beans;

import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.tree.TreePath;
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;

/**
 * GUI for displaying and editing an EvSchedule object.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */

// most of this class was generated via a gui layout ide tool so the
// code is not great.

public class EvScheduleEditorPanel extends JPanel {

  private static String downImg = "/uchicago/src/simbuilder/images/Down.gif";
  private static String upImg = "/uchicago/src/simbuilder/images/Up.gif";


  BorderLayout borderLayout1 = new BorderLayout();
  JSplitPane jSplitPane1 = new JSplitPane();
  JScrollPane jScrollPane1 = new JScrollPane();
  ScheduleEditorTree tree;
  JPanel listPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel buttonPanel = new JPanel();
  JButton btnDown = new JButton();
  JButton btnUp = new JButton();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList scheduleList = new JList();
  JList lastScheduleList = new JList();
  JPanel jPanel2 = new JPanel();
  JButton btnOk = new JButton();
  JButton btnCancel = new JButton();

  private ArrayList actionList = new ArrayList();
  private ArrayList lastActionList = new ArrayList();
  private ArrayList curList = new ArrayList();
  private JList curJList = null;
  private EvScheduleEditor editor;
  private JDialog dialog;

  public EvScheduleEditorPanel(EvSchedule schedule) {
    try {
      jbInit(schedule);
      addListeners();
    } catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit(EvSchedule schedule) throws Exception {
    tree = new ScheduleEditorTree(schedule);
    this.setLayout(borderLayout1);
    listPanel.setLayout(borderLayout2);
    //btnDown.setText("Down");
    //btnUp.setText("Up");
    btnUp.setIcon(new ImageIcon(getClass().getResource(upImg)));
    btnDown.setIcon(new ImageIcon(getClass().getResource(downImg)));
    btnOk.setMnemonic('O');
    btnOk.setText("OK");
    btnCancel.setMnemonic('C');
    btnCancel.setText("Cancel");
    this.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(jScrollPane1, JSplitPane.LEFT);
    jSplitPane1.add(listPanel, JSplitPane.RIGHT);
    listPanel.add(buttonPanel, BorderLayout.SOUTH);
    buttonPanel.add(btnUp, null);
    buttonPanel.add(btnDown, null);
    //listPanel.add(jScrollPane2, BorderLayout.CENTER);
    this.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(btnOk, null);
    jPanel2.add(btnCancel, null);
    jScrollPane2.getViewport().add(scheduleList, null);
    jScrollPane1.getViewport().add(tree, null);

    JPanel first = new JPanel(new BorderLayout());
    JPanel last = new JPanel(new BorderLayout());
    first.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Actions"));
    first.add(jScrollPane2, BorderLayout.CENTER);
    last.setBorder(BorderFactory.createTitledBorder(BorderFactory.createEtchedBorder(), "Last Actions"));
    last.add(new JScrollPane(lastScheduleList), BorderLayout.CENTER);
    JPanel centerPanel = new JPanel(new BorderLayout());
    centerPanel.add(first, BorderLayout.CENTER);
    centerPanel.add(last, BorderLayout.SOUTH);
    listPanel.add(centerPanel, BorderLayout.CENTER);
  }

  private void addListeners() {

    tree.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        TreePath path = tree.getPathForLocation(evt.getX(), evt.getY());
        if (path != null) {
          SchTreeNode node = (SchTreeNode) path.getLastPathComponent();
          if (!node.isDir()) {
            actionList = node.getActions();
            lastActionList = node.getLastActions();
            scheduleList.setListData(node.getActions().toArray());
            lastScheduleList.setListData(node.getLastActions().toArray());
          }
        }
      }
    });

    btnUp.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (curJList != null) {
          int curIndex = curJList.getSelectedIndex();
          if (curIndex > 0) {
            curList.add(curIndex - 1, curList.remove(curIndex));
            curJList.setListData(curList.toArray());
            curJList.setSelectedIndex(curIndex - 1);
          }
        }
      }
    });

    btnDown.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (curJList != null) {
          int curIndex = curJList.getSelectedIndex();
          int max = curList.size() - 1;
          if (curIndex < max && curIndex > -1) {
            curList.add(curIndex + 1, curList.remove(curIndex));
            curJList.setListData(curList.toArray());
            curJList.setSelectedIndex(curIndex + 1);
          }
        }
      }
    });

    btnOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) {
          //System.out.println(dialog.getSize());
          //System.out.println(jSplitPane1);
          dialog.dispose();
        }
        editor.setValue(tree.getSchedule());
        editor.firePropertyChange();
      }
    });

    btnCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) {
          dialog.dispose();
        }
      }
    });

    scheduleList.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
        if (!evt.getValueIsAdjusting()) {
          curList = actionList;
          curJList = scheduleList;
        }
      }
    });

    lastScheduleList.addListSelectionListener(new ListSelectionListener() {
      public void valueChanged(ListSelectionEvent evt) {
        if (!evt.getValueIsAdjusting()) {
          curList = lastActionList;
          curJList = lastScheduleList;
        }
      }
    });
  }

  public void display(JFrame f, EvScheduleEditor editor) {
    this.editor = editor;
    dialog = new JDialog(f, false);
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.getContentPane().add(this, BorderLayout.CENTER);
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        dialog.dispose();
      }
    });

    dialog.pack();
    dialog.setSize(460, 400);
    jSplitPane1.setDividerLocation(166);
    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }

  public static void main(String[] args) {
    final JFrame f = new JFrame();
    EvSchedule schedule = new EvSchedule();
    ScheduleDetails details = new ScheduleDetails();
    details.addDetail(new ScheduleDetail("record", 1L, details.EVERY_TICK, false));
    details.addDetail(new ScheduleDetail("write", 10L, details.AT_INTERVAL, true));
    details.addDetail(new ScheduleDetail("actionZ", 10L, details.AT_INTERVAL, true));
    details.addDetail(new ScheduleDetail("actionX", 10L, details.AT_INTERVAL, false));
    details.addDetail(new ScheduleDetail("actionY", 10L, details.AT_INTERVAL, false));
    details.addDetail(new ScheduleDetail("go", 1L, details.EVERY_TICK, false));
    details.addDetail(new ScheduleDetail("write", 3L, details.END, false));
    schedule.addScheduleDetails(details);

    EvScheduleEditorPanel ev = new EvScheduleEditorPanel(schedule);
    f.getContentPane().setLayout(new BorderLayout());
    f.getContentPane().add(ev, BorderLayout.SOUTH);
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        f.dispose();
        System.exit(0);
      }
    });

    f.pack();
    f.setVisible(true);
  }
}
