package uchicago.src.simbuilder.beans;

import java.beans.IntrospectionException;
import java.beans.PropertyDescriptor;
import java.beans.SimpleBeanInfo;

/**
 * A BeanInfo base class for BeanInfo classes used by simbuilder beans.
 * This is simple extension of SimpleBeanInfo with the addition of a
 * simple property filtering mechanism.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
public class EvolverBeanInfo extends SimpleBeanInfo {

  protected Class beanClass;
  private String[][] propList;

  public EvolverBeanInfo(Class beanClass, String[][] propList) {
    super();
    this.beanClass = beanClass;
    this.propList = propList;
  }

  public PropertyDescriptor[] getPropertyDescriptors() {
    //if (propList == null) return null;

    PropertyDescriptor[] pds = new PropertyDescriptor[propList.length];
    try {
      for (int i = 0, n = propList.length; i < n; i++) {
        String[] p = propList[i];
        PropertyDescriptor pd = new PropertyDescriptor(p[1], beanClass);
        pds[i] = pd;
        pd.setDisplayName(p[0]);
      }
    } catch (IntrospectionException ex) {
      ex.printStackTrace();
    }

    return pds;
  }
}

