package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Property Editor for ModelParameter properties.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
public class FieldsPropertyEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private FieldsPropertyPanel ppanel;
  private JLabel label = EvolverPropertyEditor.getLabel();
  private Fields params;

  public FieldsPropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Fields");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);
    
    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    params = ((Fields) val).copy();
    label.setText(params.size() + " field(s)");
    //System.out.println("params: ");
    //System.out.println(params);
  }

  public Object getValue() {
    return params.copy();
  }

  public void showDialog() {
    // pass copy so any changes to FieldsPropertyPanel copy and then a
    // cancel are not reflected here.
    ppanel = new FieldsPropertyPanel(params.copy());
    ppanel.display((JFrame) panel.getTopLevelAncestor(), this);
  }
  
  /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    EvolverCompileable compileable = (EvolverCompileable) bean;
    compileable.setParameters((Fields)getValue());
  }
}
