package uchicago.src.simbuilder.beans;

import javax.swing.*;
import javax.swing.tree.DefaultMutableTreeNode;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * A TreeNode (an item displayed in JTrees) view of
 * the *ScheduleUnit-s. These are displayed in the
 * ScheduleEditorTree which is used by EvScheduleEditorPanel.
 * This then is part of the gui for working with EvSchedule
 * properties.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
class SchTreeNode extends DefaultMutableTreeNode {

  public static final HashMap intToName = new HashMap();

  public static final Integer EVERY_TICK = new Integer(1);
  public static final Integer AT_INTERVAL = new Integer(2);
  public static final Integer AT = new Integer(3);
  public static final Integer AT_END = new Integer(4);
  public static final Integer AT_PAUSE = new Integer(5);
  public static final Integer LAST = new Integer(6);
  public static final Integer FIRST = new Integer(7);
  public static final Integer TICK = new Integer(8);

  static {
    intToName.put(new Integer(1), "EVERY TICK");
    intToName.put(new Integer(2), "AT INTERVAL");
    intToName.put(new Integer(3), "AT");
    intToName.put(new Integer(4), "AT END");
    intToName.put(new Integer(5), "AT PAUSE");
  }

  private ArrayList actionList = new ArrayList();
  private ArrayList lastActionList = new ArrayList();
  private String name;
  private Integer id;
  private boolean isDir = false;
  private AbstractScheduleUnit unit = null;

  static final ImageIcon FOLDER = new ImageIcon(String.class.getResource("/uchicago/src/simbuilder/images/Folder.gif"));
  static final ImageIcon ACTION = new ImageIcon(String.class.getResource("/uchicago/src/simbuilder/images/Enter.gif"));

  public SchTreeNode(String name, Integer id, boolean isDir) {
    this.name = name;
    this.id = id;
    this.isDir = isDir;
  }

  public boolean isDir() {
    return isDir;
  }

  public void setScheduleUnit(AbstractScheduleUnit unit) {
    this.unit = unit;
  }

  public AbstractScheduleUnit getScheduleUnit() {
    return unit;
  }

  public void setActions(ArrayList val) {
    actionList = val;
  }

  public ArrayList getActions() {
    return actionList;
  }

  public void setLastActions(ArrayList val) {
    lastActionList = val;
  }

  public ArrayList getLastActions() {
    return lastActionList;
  }


  public String toString() {
    return name;
  }

  public Integer getId() {
    return id;
  }
}
