package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class ScheduleDetailsPropertyEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private JLabel label = EvolverPropertyEditor.getLabel();
  private ScheduleDetails details;

  public ScheduleDetailsPropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Schedule");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    details = ((ScheduleDetails) val).copy();
    label.setText(details.size() + " schedule item(s)");
    //System.out.println("params: ");
    //System.out.println(params);
  }

  public Object getValue() {
    return details.copy();
  }

  public void showDialog() {
    // pass copy so any changes to FieldsPropertyPanel copy and then a
    // cancel are not reflected here.
    ScheduleDetailPropertyPanel p = new ScheduleDetailPropertyPanel(details.copy());
    p.display((JFrame) panel.getTopLevelAncestor(), this);
  }

  /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    Schedulable schedulable = (Schedulable) bean;
    schedulable.setSchedule((ScheduleDetails)getValue());
  }
}
