package uchicago.src.simbuilder.beans;

import javax.swing.*;
import javax.swing.tree.DefaultTreeCellRenderer;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreePath;
import javax.swing.tree.TreeSelectionModel;
import java.awt.*;
import java.util.ArrayList;

/**
 * Tree view of the *ScheduleUnits in an EvSchedule.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
public class ScheduleEditorTree extends JTree {

  private EvSchedule schedule;

  public ScheduleEditorTree(EvSchedule evSchedule) {
    super();
    setRootVisible(false);
    setShowsRootHandles(true);
    setModel(new DefaultTreeModel(evSchedule.makeNode()));
    this.setCellRenderer(new SchTreeRenderer());
    this.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    schedule = evSchedule;
  }

  public ArrayList getSelectedActions(TreePath path) {
    SchTreeNode node = (SchTreeNode) path.getLastPathComponent();
    return node.getActions();
  }

  public EvSchedule getSchedule() {
    return schedule;
  }

  class SchTreeRenderer extends DefaultTreeCellRenderer {

    public Component getTreeCellRendererComponent(JTree tree, Object value,
                                                  boolean sel, boolean expanded, boolean leaf,
                                                  int row, boolean hasFocus) {
      super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf,
              row, hasFocus);

      SchTreeNode node = (SchTreeNode) value;
      if (node.isDir())
        setIcon(SchTreeNode.FOLDER);
      else
        setIcon(SchTreeNode.ACTION);


      return this;
    }
  }
}
