package uchicago.src.simbuilder.beans;

import java.awt.*;

/**
 * Describes the NQPy that will become the method part of
 * a Sequence.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:26 $
 */
public class SequenceActionCode extends ActionCode {

  private Color color = null;
  private int style = -1;

  public SequenceActionCode(String name) {
    super(name);
    retType = "double";
  }

  public Object copy() {
    SequenceActionCode newCode = new SequenceActionCode(name);
    newCode.retType = retType;
    newCode.access = access;
    newCode.code = code;
    newCode.imports = imports;
    newCode.paramNames = paramNames;
    newCode.definingBean = definingBean;
    newCode.color = color;
    newCode.style = style;

    return newCode;
  }

  public Color getColor() {
    return color;
  }

  public void setColor(Color color) {
    this.color = color;
  }

  public int getStyle() {
    return style;
  }

  public void setStyle(int style) {
    this.style = style;
  }


  public String getBuildStatement() {
    StringBuffer b = new StringBuffer();
    b.append("createSequence(\"");
    b.append(name);
    b.append("\", ");
    if (color != null) {
      b.append("Color(");
      b.append(color.getRed());
      b.append(", ");
      b.append(color.getGreen());
      b.append(", ");
      b.append(color.getBlue());
      b.append("), ");
    }

    if (style != -1) {
      b.append(style);
      b.append(", ");
    }

    b.append("self, \"");
    b.append(name);
    b.append("\")");
    b.append("\n");

    return b.toString();
  }

  public String toXML() {
    StringBuffer b = new StringBuffer("<");
    b.append(EvolverConstants.XMLNS);
    b.append(":seqAction name=\"");
    b.append(name);
    b.append("\" imports=\"");
    for (int i = 0; i < imports.size(); i++) {
      if (i != 0) b.append(" ");
      b.append(imports.get(i));
    }

    b.append("\" retVal=\"");
    b.append(retType);
    b.append("\" paramNames=\"");
    for (int i = 0; i < paramNames.size(); i++) {
      if (i != 0) b.append(" ");
      b.append(paramNames.get(i));
    }

    b.append("\" color=\"");
    if (color != null) {
      b.append(color.getRed());
      b.append(" ");
      b.append(color.getGreen());
      b.append(" ");
      b.append(color.getBlue());
    }

    b.append("\" pointType=\"");
    b.append(style);

    b.append("\">");
    b.append("\n<![CDATA[\n");
    b.append(code);
    b.append("\n]]>\n</");
    b.append(EvolverConstants.XMLNS);
    b.append(":seqAction>\n");
    return b.toString();
  }
}
