package uchicago.src.simbuilder.beans;

import uchicago.src.guiUtils.CodeDocument;
import uchicago.src.guiUtils.ColorIcon;
import uchicago.src.nqpy.compiler.AbstractCompilerException;
import uchicago.src.sim.analysis.MarkListRenderer;
import uchicago.src.simbuilder.NQPyTokenizer;
import uchicago.src.simbuilder.beans.network.ActionNameDialog;

import javax.swing.*;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.border.TitledBorder;
import javax.swing.plaf.basic.BasicComboPopup;
import javax.swing.plaf.basic.ComboPopup;
import javax.swing.plaf.metal.MetalComboBoxUI;
import javax.swing.text.DefaultEditorKit;
import javax.swing.text.Keymap;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

/**
 * GUI class for Actions property editor.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */

// note most of the code here was generated by an gui ide tool. So
// its neither clean nor elegant.

public class SequencePropertyPanel extends JPanel {
  private static final String newGif =
          "/uchicago/src/simbuilder/images/New.gif";
  private static final String saveGif =
          "/uchicago/src/simbuilder/images/Save.gif";
  private static final String delGif =
          "/uchicago/src/simbuilder/images/Delete.gif";

  BorderLayout borderLayout1 = new BorderLayout();
  JToolBar tBar = new JToolBar();
  JPanel top = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel viPanel = new JPanel();
  JPanel varsPanel = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel importsPanel = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  JPanel sourcePanel = new JPanel();
  JPanel btnPanel = new JPanel();
  JScrollPane jScrollPane1 = new JScrollPane();
  DragList varList = new DragList(new DefaultListModel());
  BorderLayout borderLayout4 = new BorderLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JScrollPane jScrollPane3 = new JScrollPane();
  JTextArea impEditorPane = new JTextArea();
  BorderLayout borderLayout5 = new BorderLayout();
  DragTextPane sourceEditorPane;
  JButton btnNew = new JButton();
  JButton btnDel = new JButton();
  Component component1;
  JComboBox cmbActions = new JComboBox(new DefaultComboBoxModel());
  BorderLayout borderLayout6 = new BorderLayout();
  JButton btnSave = new JButton();
  JButton btnOk = new JButton();
  JButton btnCancel = new JButton();

  JTextField fldName = new JTextField();

  private JDialog dialog;
  private SequencesEditor editor;
  private Sequences actions;
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JSplitPane jSplitPane1 = new JSplitPane();
  JPanel errorPanel = new JPanel();
  JScrollPane jScrollPane4 = new JScrollPane();
  JList errorList = new JList(new DefaultListModel());
  BorderLayout borderLayout8 = new BorderLayout();
  Border border2;
  TitledBorder titledBorder2;

  private CodeDocument doc;
  private HashMap nameIndex = new HashMap();
  private int paramCount = 0;
  private int curIndex = -1;
  private JComboBox markBox;
  private JComboBox colorBox;
  private Object lastColorItem;

  class ColorBoxRenderer extends JLabel implements ListCellRenderer {

    public Component getListCellRendererComponent(JList list,
                                                  Object value,
                                                  int index,
                                                  boolean isSelected,
                                                  boolean cellHasFocus) {
      if (value instanceof Color) {
        setHorizontalAlignment(JLabel.CENTER);
        setText("");
        setIcon(new ColorIcon((Color) value, 14));
      } else {
        setHorizontalAlignment(JLabel.LEFT);
        setText(value.toString());
        setIcon(null);
      }

      return this;
    }
  }

  class ColorBoxUI extends MetalComboBoxUI {
    protected ComboPopup createPopup() {
      BasicComboPopup popup = new BasicComboPopup(comboBox) {
        public void show() {
          Dimension popupSize = new Dimension(100, 0);
          popupSize.setSize(popupSize.width,
                  getPopupHeightForRowCount
                  (comboBox.getMaximumRowCount()));

          Rectangle popupBounds = computePopupBounds
                  (0, comboBox.getBounds().height,
                          popupSize.width, popupSize.height + 2);

          scroller.setMaximumSize(popupBounds.getSize());
          scroller.setPreferredSize(popupBounds.getSize
                  ());
          scroller.setMinimumSize(popupBounds.getSize());

          list.invalidate();

          int selectedIndex = comboBox.getSelectedIndex();

          if (selectedIndex == -1) {
            list.clearSelection();
          } else {
            list.setSelectedIndex(selectedIndex);
          }

          list.ensureIndexIsVisible(list.getSelectedIndex
                  ());

          setLightWeightPopupEnabled
                  (comboBox.isLightWeightPopupEnabled());

          show(comboBox, popupBounds.x, popupBounds.y);
        }
      };

      popup.getAccessibleContext().setAccessibleParent(comboBox);
      return popup;
    }
  }

  class ErrorItem {
    AbstractCompilerException ex;
    String rep;

    public ErrorItem(AbstractCompilerException ex) {
      this.ex = ex;
      rep = ex.getMessage();
    }

    public String toString() {
      return rep;
    }
  }

  class ErrorRenderer extends JTextArea implements ListCellRenderer {

    public Component getListCellRendererComponent(JList list,
                                                  Object value,
                                                  int index,
                                                  boolean isSelected,
                                                  boolean cellHasFocus) {
      setText(value.toString());
      this.setBackground(isSelected ? Color.red : Color.white);
      this.setForeground(isSelected ? Color.white : Color.red);
      return this;
    }
  }

  public SequencePropertyPanel(Sequences actions) {
    this.actions = actions;

    try {
      jbInit();
    } catch (Exception e) {
      e.printStackTrace();
    }

    Iterator i = actions.iterator();
    int index = 0;
    DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
    while (i.hasNext()) {
      SequenceActionCode code = (SequenceActionCode) i.next();
      nameIndex.put(code.getName(), new Integer(index++));
      model.addElement(code);
    }

    setVarNames(actions.getVarNames());
    addListeners();
    if (model.getSize() > 0) cmbActions.setSelectedIndex(0);
    btnSave.setEnabled(model.getSize() > 0);
    btnDel.setEnabled(model.getSize() > 0);
  }

  private void setupEditorPane() {
    NQPyTokenizer t = new NQPyTokenizer();
    doc = new CodeDocument(t);
    sourceEditorPane = new DragTextPane(doc);
    Keymap map = sourceEditorPane.getKeymap();
    Hashtable acts = createActionTable(sourceEditorPane);
    KeyStroke key = KeyStroke.getKeyStroke(KeyEvent.VK_E, Event.CTRL_MASK);
    map.addActionForKeyStroke(key, (Action) acts.get(DefaultEditorKit.endLineAction));
    map.addActionForKeyStroke(KeyStroke.getKeyStroke(KeyEvent.VK_A, Event.CTRL_MASK), (Action) acts.get(DefaultEditorKit.beginLineAction));
  }

  private Hashtable createActionTable(DragTextPane txt) {
    Hashtable actions = new Hashtable();
    Action[] actionsArray = txt.getActions();
    for (int i = 0; i < actionsArray.length; i++) {
      Action a = actionsArray[i];
      actions.put(a.getValue(Action.NAME), a);
    }
    return actions;
  }


  private void jbInit() throws Exception {

    setupEditorPane();
    border1 = BorderFactory.createBevelBorder(BevelBorder.RAISED, Color.white, Color.white, new Color(142, 142, 142), new Color(99, 99, 99));
    titledBorder1 = new TitledBorder(border1, "Variables");
    component1 = Box.createHorizontalStrut(8);
    border2 = BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142));
    titledBorder2 = new TitledBorder(border2, "Errors");
    this.setLayout(borderLayout1);
    this.setMaximumSize(new Dimension(55, 44));
    this.setMinimumSize(new Dimension(55, 44));
    top.setLayout(borderLayout2);
    viPanel.setLayout(borderLayout3);
    varsPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Variables"));
    varsPanel.setLayout(borderLayout6);
    importsPanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Java Imports"));
    importsPanel.setLayout(borderLayout4);
    sourcePanel.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Source"));
    sourcePanel.setLayout(borderLayout5);

    btnNew.setRequestFocusEnabled(false);
    btnNew.setToolTipText("New Action");
    btnNew.setIcon(new ImageIcon(this.getClass().getResource(newGif)));
    btnSave.setIcon(new ImageIcon(this.getClass().getResource(saveGif)));
    btnSave.setToolTipText("Save Action");
    btnDel.setRequestFocusEnabled(false);
    btnDel.setToolTipText("Delete Action");
    btnDel.setIcon(new ImageIcon(this.getClass().getResource(delGif)));
   
    int height = btnDel.getPreferredSize().height;
    cmbActions.setMaximumSize(new Dimension(150, height));
    cmbActions.setMinimumSize(new Dimension(150, height));
    cmbActions.setPreferredSize(new Dimension(150, height));

    btnOk.setText("OK");
    btnCancel.setText("Cancel");
    sourceEditorPane.setFont(new Font("Monospaced", 0, 12));
    btnPanel.setLayout(borderLayout7);
    jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setDividerSize(4);
    errorPanel.setLayout(borderLayout8);
    errorPanel.setBorder(titledBorder2);
    this.add(top, BorderLayout.NORTH);
    JPanel controls = new JPanel(new BorderLayout());
    controls.add(tBar, BorderLayout.NORTH);
    top.add(controls, BorderLayout.NORTH);
    tBar.add(btnNew, null);
    tBar.add(btnSave, null);
    tBar.add(btnDel, null);
    tBar.add(component1, null);
    tBar.add(cmbActions, null);

    Object[] markTypes = {new Integer(-1), new Integer(1), new Integer(2), new Integer(3),
                          new Integer(4), new Integer(5), new Integer(6),
                          new Integer(7), new Integer(8), new Integer(9)};
    markBox = new JComboBox(markTypes);
    markBox.setRenderer(new MarkListRenderer());
    Dimension d = new Dimension(60, 31);
    markBox.setPreferredSize(d);
    markBox.setMaximumSize(d);
    markBox.setMinimumSize(d);

    JPanel boxes = new JPanel(new FlowLayout(FlowLayout.LEFT));
    boxes.setBorder(new TitledBorder(BorderFactory.createEtchedBorder(Color.white, new Color(142, 142, 142)), "Style"));
    boxes.add(new JLabel("Point Style: "));
    boxes.add(markBox);
    controls.add(boxes, BorderLayout.SOUTH);
    createColorBox();
    boxes.add(new JLabel("Sequence Color: "));
    boxes.add(colorBox);


    top.add(viPanel, BorderLayout.CENTER);
    viPanel.add(varsPanel, BorderLayout.WEST);
    jScrollPane1 = new JScrollPane(varList);
    varsPanel.add(jScrollPane1, BorderLayout.CENTER);
    viPanel.add(importsPanel, BorderLayout.CENTER);
    importsPanel.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(impEditorPane, null);
    this.add(btnPanel, BorderLayout.SOUTH);
    btnPanel.add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(btnOk, null);
    jPanel1.add(btnCancel, null);
    this.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(sourcePanel, JSplitPane.LEFT);
    sourcePanel.add(jScrollPane3, BorderLayout.CENTER);
    jSplitPane1.add(errorPanel, JSplitPane.RIGHT);
    jScrollPane3.getViewport().add(sourceEditorPane, null);
    errorPanel.add(jScrollPane4, BorderLayout.CENTER);
    jScrollPane4.getViewport().add(errorList, null);

    errorList.setCellRenderer(new ErrorRenderer());
    varList.setVisibleRowCount(4);
  }

  private void createColorBox() {
    DefaultComboBoxModel model = new DefaultComboBoxModel();
    model.addElement("Auto");
    model.addElement("Choose Color ...");
    colorBox = new JComboBox(model);

    colorBox.setRenderer(new ColorBoxRenderer());
    colorBox.setUI(new ColorBoxUI());
    Dimension d = new Dimension(60, 31);
    colorBox.setPreferredSize(d);
    colorBox.setMaximumSize(d);
    colorBox.setMinimumSize(d);

    colorBox.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        if (e.getStateChange() == ItemEvent.DESELECTED) {
          lastColorItem = e.getItem();
        }
      }
    });

    colorBox.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (colorBox.getSelectedIndex() == 1) {
          Color color = JColorChooser.showDialog(SequencePropertyPanel.this,
                  "Sequence Color", null);
          DefaultComboBoxModel model = (DefaultComboBoxModel) colorBox.getModel();
          if (color != null) {
            model.addElement(color);
            model.setSelectedItem(color);
          } else {
            model.setSelectedItem(lastColorItem);
          }
        }
      }
    });
  }

  public void addToToolBar(JPanel p) {
    tBar.addSeparator();
    tBar.add(p);
  }
  
  private void doNew() {
    doSave();
    ActionNameDialog dialog = new ActionNameDialog("", "", false);
    boolean makeNew = dialog.display(this.dialog, "Sequence Name");
    if (makeNew) {
      if (dialog.getName().length() > 0) {
        DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
        SequenceActionCode code = new SequenceActionCode(dialog.getName());
        model.addElement(code);
        curIndex = model.getSize() - 1;
        sourceEditorPane.setText("");
        sourceEditorPane.requestFocus();
      }

      cmbActions.setSelectedIndex(curIndex);
    }

    btnSave.setEnabled(cmbActions.getModel().getSize() > 0);
    btnDel.setEnabled(cmbActions.getModel().getSize() > 0);
    
  }

  public void addListeners() {
    btnNew.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        doNew();
      }
    });

    btnOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) dialog.dispose();
        doSave();
        editor.setValue(getSequences());
        editor.firePropertyChange();
      }
    });

    btnCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        if (dialog != null) dialog.dispose();
      }
    });

    cmbActions.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        doSave();
        curIndex = cmbActions.getSelectedIndex();
        if (curIndex != -1) {
        SequenceActionCode code = (SequenceActionCode) cmbActions.getItemAt(curIndex);
        ArrayList imports = code.getImports();
        StringBuffer b = new StringBuffer();
        for (int i = 0; i < imports.size(); i++) {
          String imp = (String) imports.get(i);
          if (i != 0) b.append("\n");
          b.append(imp);
        }

        impEditorPane.setText(b.toString());

        DefaultListModel lm = (DefaultListModel) varList.getModel();
        if (paramCount != 0) {
          //System.out.println("param count: " + paramCount);
          //System.out.println("lm size: " + lm.size());
          lm.removeRange(lm.size() - paramCount, lm.size() - 1);
        }

        ArrayList params = code.getParameterNames();
        paramCount = params.size();
        for (int i = 0; i < paramCount; i++) {
          String pName = (String) params.get(i);
          //System.out.println("adding element: " + pName);

          lm.addElement(pName);
        }

        sourceEditorPane.setText(code.getCode());
        Color color = code.getColor();
        int style = code.getStyle();

        markBox.setSelectedItem(new Integer(style));
        if (color == null)
          colorBox.setSelectedIndex(0);
        else {
          // see if box contains the color
          DefaultComboBoxModel m = (DefaultComboBoxModel) colorBox.getModel();
          boolean notFound = true;
          for (int i = 0; i < m.getSize(); i++) {
            if (m.getElementAt(i).equals(color)) {
              colorBox.setSelectedIndex(i);
              notFound = false;
              break;
            }
          }

          if (notFound) {
            m.addElement(color);
            m.setSelectedItem(color);
          }
        }
        } else {
          sourceEditorPane.setText("");
        }
      }
    });

    btnSave.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        doSave();
      }
    });

    btnDel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (curIndex != -1) {
          SequenceActionCode codeToDelete = (SequenceActionCode) cmbActions.getItemAt(curIndex);
          actions.remove(codeToDelete.getName());
          cmbActions.removeItemAt(curIndex);
          curIndex = cmbActions.getSelectedIndex();
        }
        
        btnSave.setEnabled(cmbActions.getModel().getSize() > 0);
        btnDel.setEnabled(cmbActions.getModel().getSize() > 0);
      }
    });

    errorList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // getClickCount always returns 1. So this will never be
        // called.
        if (evt.getClickCount() == 2) {
          int index = errorList.locationToIndex(evt.getPoint());
          if (index >= 0) {
            ErrorItem item = (ErrorItem)
                    (errorList.getModel()).getElementAt(index);
            goToError(item);
          }
        }
      }
    });

    errorList.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // enter key returns VK_UNDEFINED rather than
        // VK_ENTER so check for char instead.
        if (evt.getKeyChar() == '\n') {
          int index = errorList.getSelectedIndex();
          if (index >= 0) {
            ErrorItem item = (ErrorItem)
                    (errorList.getModel()).getElementAt(index);
            goToError(item);
          }
        }
      }
    });

    varList.addMouseListener(new MouseAdapter() {
      public void mouseClicked(MouseEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // getClickCount always returns 1. So this will never be
        // called.
        if (evt.getClickCount() == 2) {
          Object o = varList.getSelectedValue();
          if (o != null) {
            insertVar(o.toString());
          }
        }
      }
    });

    varList.addKeyListener(new KeyAdapter() {
      public void keyTyped(KeyEvent evt) {
        // with IBM's jvm build cx130-20010626 on rh7.1,
        // enter key returns VK_UNDEFINED rather than
        // VK_ENTER so check for char instead.
        if (evt.getKeyChar() == '\n') {
          Object o = varList.getSelectedValue();
          if (o != null) {
            insertVar(o.toString());
          }
        }
      }
    });
  }

  private void goToError(ErrorItem item) {
    int lineNum = item.ex.getLineNum();
    int pos = doc.highlightError(lineNum);
    sourceEditorPane.setCaretPosition(pos);
    sourceEditorPane.requestFocus();
  }

  private void insertVar(String var) {
    int pos = sourceEditorPane.getCaretPosition();
    sourceEditorPane.replaceSelection(var);
    sourceEditorPane.setCaretPosition(pos + var.length());
    sourceEditorPane.requestFocus();
  }

  private void doSave() {
    if (curIndex != -1) {
      SequenceActionCode code = (SequenceActionCode) cmbActions.getItemAt(curIndex);
      code.setCode(sourceEditorPane.getText());
      String imps = impEditorPane.getText().trim();
      if (imps.length() != 0) {
        ArrayList l = new ArrayList();
        StringTokenizer t = new StringTokenizer(imps);
        while (t.hasMoreTokens()) {
          l.add(t.nextToken());
        }

        code.setImports(l);
      }

      Object color = colorBox.getSelectedItem();
      if (color instanceof Color) {
        code.setColor((Color) color);
      } else {
        code.setColor(null);
      }

      Integer i = (Integer) markBox.getSelectedItem();
      code.setStyle(i.intValue());

      nameIndex.put(code.getName(), new Integer(curIndex));
    }
  }

  public Sequences getSequences() {
    actions.clear();
    DefaultComboBoxModel model = (DefaultComboBoxModel) cmbActions.getModel();
    //System.out.println("model size: " + model.getSize());
    for (int i = 0; i < model.getSize(); i++) {
      actions.addAction((SequenceActionCode) model.getElementAt(i));
    }

    return actions;
  }

  public void addError(AbstractCompilerException ex) {
    ((DefaultListModel) errorList.getModel()).add(0, new ErrorItem(ex));
    String block = ex.getBlockName();
    String method = block.substring(block.lastIndexOf(".") + 1, block.length());
    int index = ((Integer) nameIndex.get(method)).intValue();
    cmbActions.setSelectedIndex(index);
  }

  public void setVarNames(ArrayList names) {
    //System.out.println("setting varNames");

    String self = "self.";
    DefaultListModel model = (DefaultListModel) varList.getModel();
    model.clear();
    int size = names.size();
    for (int i = 0; i < size; i++) {
      model.addElement(self + names.get(i));
    }
  }

  public void display(JFrame f, SequencesEditor editor) {
    this.editor = editor;
    dialog = new JDialog(f, false);
    dialog.setTitle("Series Editor");
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.getContentPane().add(this, BorderLayout.CENTER);
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        dialog.dispose();
      }
    });

    if ((errorList.getModel()).getSize() > 0) {
      jSplitPane1.setDividerLocation(220);
      dialog.pack();
      dialog.setSize(650, 550);
      errorList.setVisibleRowCount(4);

    } else {
      errorPanel.setVisible(false);
      dialog.pack();
      dialog.setSize(650, 450);
    }

    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }
}

