package uchicago.src.simbuilder.beans;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */
public class SequencesEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private JLabel label = EvolverPropertyEditor.getLabel();
  private Sequences actions = new Sequences();

  public SequencesEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Series");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    actions = new Sequences((Sequences) val);
    label.setText(actions.size() + " Series");
  }

  public Object getValue() {
    return new Sequences(actions);
  }

  private void showDialog() {
    SequencePropertyPanel aPanel =
            new SequencePropertyPanel(new Sequences(actions));
    aPanel.display((JFrame) panel.getTopLevelAncestor(), this);
  }
  
   /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    SequenceGraph graph = (SequenceGraph) bean;
    graph.setSequences((Sequences) getValue());
  }

}
