package uchicago.src.simbuilder.beans.gis;

import uchicago.src.simbuilder.EvolverController;
import uchicago.src.simbuilder.beans.EvolverBeanInfo;
import uchicago.src.simbuilder.beans.ModelProducerBeanInfo;

import javax.swing.*;
import java.awt.*;
import java.beans.BeanDescriptor;

/**
 * BeanInfo for the NetworkModelProducer.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */

public class DefaultGISModelProducerBeanInfo extends EvolverBeanInfo implements ModelProducerBeanInfo {

  public static String ICON_IMAGE = "/uchicago/src/simbuilder/images/World2.gif";
  private static final String[][] props = {{"Actions", "actions"},
                                           {"Display Name", "displayName"},
                                           {"GIS Package", "gisPackage"},
                                           {"Master Schedule", "masterSchedule"},
                                           {"Model Name", "modelName"},
                                           {"Fields", "parameters"},
                                           {"Schedule", "schedule"}};

  public DefaultGISModelProducerBeanInfo() {
    super(uchicago.src.simbuilder.beans.gis.DefaultGISModelProducer.class, props);
  }


  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor bd = new BeanDescriptor(beanClass);
    bd.setDisplayName("Default GIS Model");
    return bd;
  }


  public Image getIcon(int iconKind) {
    return new ImageIcon(getClass().getResource(ICON_IMAGE)).getImage();
  }

  public void loadModelProducer(EvolverController controller, boolean loadModel) {
    controller.loadPalette("GIS");
    if (loadModel) controller.addBeanToTree("GIS", "uchicago.src.simbuilder.beans.gis.DefaultGISModelProducer", 0);
  }
}
