package uchicago.src.simbuilder.beans.gis;

import java.awt.*;

/**
 * @author Nick Collier
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */
public class LineSymbolIcon implements SymbolIcon {
  
  private Color color;
  private int width = 20;
  private int height = 10;
  private BasicStroke stroke;
  
  public LineSymbolIcon(Color color, float thickness) {
   this(color, thickness, 20, 10); 
  }
  public LineSymbolIcon(Color color, float thickness, int width, int height) {
    this.color = color;
    stroke = new BasicStroke(thickness);
    this.width = width;
    this.height = height;
  }

  public Color getColor() {
    return color;
  }

  public void setColor(Color color) {
    this.color = color;
  }
  
  public int getThickness() {
    return (int)stroke.getLineWidth();
  }
  
  public void setThickness(int thickness) {
    stroke = new BasicStroke(thickness);
  }

  public int getIconWidth() {
    return width;
  }

  public int getIconHeight() {
    return height;
  }

  public void paintIcon(Component comp, Graphics g, int x, int y) {
    Color c = g.getColor();
    Graphics2D g2 = (Graphics2D)g;
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                        RenderingHints.VALUE_ANTIALIAS_ON);
    g.setColor(color);
    //int centerY = y + (height / 2) - (int)(stroke.getLineWidth() / 2);
    //if (centerY < y) centerY = y;
    g2 = ((Graphics2D)g);
    Stroke defStroke = g2.getStroke();
    g2.setStroke(stroke);
    int centerY = y + height / 2;
    g2.drawLine(x, centerY, x + width, centerY);
    g2.setStroke(defStroke);
    g.setColor(c);
    g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
                        RenderingHints.VALUE_ANTIALIAS_OFF);
  }
}
