package uchicago.src.simbuilder.beans.gis;

import javax.swing.*;

/**
 * @author Nick Collier
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */
public class SymbolValuePair implements Comparable {
  
  private SymbolIcon icon;
  private String value;
  boolean isDefault = false;
  
  public SymbolValuePair(SymbolIcon icon, String value) {
    this(icon, value, false);
  }

  public SymbolValuePair(SymbolIcon icon, String value, boolean isDefault) {
    this.icon = icon;
    this.value = value;
    this.isDefault = isDefault;
  }
  
  public SymbolIcon getIcon() {
    return icon;
  }

  public String getValue() {
    return value;
  }

  public int compareTo(Object o) {
    SymbolValuePair other = (SymbolValuePair) o;
    if (isDefault && other.isDefault) return 0;
    if (isDefault) return -1;
    if (other.isDefault) return 1;
    return value.compareTo(other.value);
  }

  public boolean isDefault() {
    return isDefault;
  }
}
