package uchicago.src.simbuilder.beans.gis;

import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Editor for Actions properties.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */

public class VectorDataSourcePropertyEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private JLabel label = EvolverPropertyEditor.getLabel();
  private VectorDataSource dataSource;

  public VectorDataSourcePropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Data Source");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    dataSource = (VectorDataSource) val;
    if (dataSource.isValid())
      label.setForeground(Color.BLACK);
    else
      label.setForeground(Color.RED);
    label.setText(dataSource.getShapefileDisplayName());
  }

  public Object getValue() {
    return new VectorDataSource(dataSource);
  }

  private void showDialog() {
    VectorDataSourcePropertyPanel panel = new VectorDataSourcePropertyPanel(new VectorDataSource(dataSource));
    panel.display((JFrame) panel.getTopLevelAncestor(), this);
  }
  
  /**
   * Sets the bean's property from the current value in the editor.
   *
   * @param bean
   */
  public void setPropertyFromValue(Object bean) {
    VectorAgentProducer producer = (VectorAgentProducer) bean;
    producer.setDatasource((VectorDataSource) getValue());
  }
}
