package uchicago.src.simbuilder.beans.gis;

import javax.swing.table.AbstractTableModel;

/**
 * TableModel for the JTable used in FieldsPropertyPanel.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:27 $
 */
public class VectorFieldsTableModel extends AbstractTableModel {

  private static final String[] COL_NAMES = {"Name", "Type", "Enabled"};
  private VectorDataSource dataSource;

  public VectorFieldsTableModel(VectorDataSource dataSource) {
    this.dataSource = dataSource;
  }

  public int getRowCount() {
    return dataSource.fieldCount();
  }

  public int getColumnCount() {
    return COL_NAMES.length;
  }

  public String getColumnName(int col) {
    return COL_NAMES[col];
  }

  public Class getColumnClass(int col) {
    if (col == 2) return Boolean.class;
    return String.class;
  }

  public void setValueAt(Object aValue, int rowIndex, int columnIndex) {
    Boolean enabled = (Boolean) aValue;
    dataSource.setFieldEnabled(rowIndex, enabled.booleanValue());
    fireTableCellUpdated(rowIndex, columnIndex);
  }

  public boolean isCellEditable(int row, int col) {
    return col == 2;
  }

  public Object getValueAt(int row, int col) {
    if (col == 0)
      return dataSource.getFieldNameAt(row);
    else if (col == 1)
      return dataSource.getFieldClassAt(row).getName();
    else if (col == 2) return new Boolean(dataSource.isFieldEnabled(row));
    return null;
  }

  public void update() {
    fireTableDataChanged();
  }
}
