package uchicago.src.simbuilder.beans.grid;

import uchicago.src.simbuilder.EvolverController;
import uchicago.src.simbuilder.beans.EvolverBeanInfo;
import uchicago.src.simbuilder.beans.ModelProducerBeanInfo;

import javax.swing.*;
import java.awt.*;
import java.beans.BeanDescriptor;

/**
 * BeanInfo for the GridModelProducer.
 *
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:28 $
 */

public class GridModelProducerBeanInfo extends EvolverBeanInfo implements ModelProducerBeanInfo {

  public static String IMAGE = "/uchicago/src/simbuilder/images/Row.gif";
  private static final String[][] props = {{"Actions", "actions"},
                                           {"Display Name", "displayName"},
                                           {"Master Schedule", "masterSchedule"},
                                           {"Model Name", "modelName"},
                                           {"Space Width", "spaceWidth"},
                                           {"Space Height", "spaceHeight"},
                                           {"Fields", "parameters"},
                                           {"Space Type", "spaceType"},
                                           {"Schedule", "schedule"}};


  public GridModelProducerBeanInfo() {
    super(uchicago.src.simbuilder.beans.grid.GridModelProducer.class, props);
  }


  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor bd = new BeanDescriptor(beanClass);
    bd.setDisplayName("Grid Model");
    return bd;
  }


  public Image getIcon(int iconKind) {
    return new ImageIcon(getClass().getResource(IMAGE)).getImage();
  }

  public void loadModelProducer(EvolverController controller, boolean loadModel) {
    controller.loadPalette("Grid");
    if (loadModel) controller.addBeanToTree("Grid", "uchicago.src.simbuilder.beans.grid.GridModelProducer", 0);
  }
}
