package uchicago.src.simbuilder.beans.network;

import uchicago.src.simbuilder.beans.EvolverConstants;

import java.util.HashMap;

public class CircularLayoutProperty implements LayoutProperty {

  private int margin = 6;

  public CircularLayoutProperty() {
  }

  public CircularLayoutProperty(CircularLayoutProperty layout) {
    margin = layout.margin;
  }

  public LayoutProperty copy() {
    return new CircularLayoutProperty(this);
  }

  public boolean isEditable() {
    return true;
  }

  public int getMargin() {
    return margin;
  }

  public void setMargin(int val) {
    margin = val;
  }

  public String getInitScript(String varName, String ctorArgs, String dispName) {
    StringBuffer b = new StringBuffer(varName);
    b.append(" = CircularGraphLayout(");
    b.append(ctorArgs);
    b.append(")\n");
    b.append(varName);
    b.append(".setPad(");
    b.append(margin);
    b.append(")\n");
    return b.toString();
  }

  public String[] getProperties() {
    return new String[]{"Margin"};
  }

  public String toXML() {
    String xmlString = EvolverConstants.XMLNS + ":network_display";
    StringBuffer b = new StringBuffer("<");
    b.append(xmlString);
    b.append(" class=\"");
    b.append(getClass().getName());
    b.append("\"");
    b.append(" margin=\"");
    b.append(margin);
    b.append("\" />");
    return b.toString();
  }

  public void fromMap(HashMap map) {
    Integer i = Integer.valueOf((String) map.get("margin"));
    setMargin(i.intValue());
  }

  public String getClassName() {
    return "uchicago.src.sim.gui.CircularGraphLayout";
  }
}
