package uchicago.src.simbuilder.beans.network;

import uchicago.src.sim.engine.CustomProbeable;
import uchicago.src.sim.games.GameAgent;
import uchicago.src.sim.network.DefaultDrawableNode;

import java.awt.*;


/**
 * A subclass of DefaultNode that the dynamically compiled
 * network node agent in Evolver-created models should extend.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:28 $
 */
public abstract class EvolverNodeImpl extends DefaultDrawableNode implements
        GameAgent, CustomProbeable {

  protected int strategy = LEFT;
  protected Color color = Color.blue;
  protected float payoff;

  public void setPayoff(float val) {
    payoff = val;
  }

  public float getPayoff() {
    return payoff;
  }

  public int getStrategy() {
    return strategy;
  }

  public void setStrategy(int val) {
    strategy = val;
  }
}
