package uchicago.src.simbuilder.beans.network;

import uchicago.src.reflector.IntrospectPanel;

import javax.swing.*;
import javax.swing.border.Border;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class LayoutPropertyPanel extends JPanel {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel ctrPanel = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  JPanel btnPanel = new JPanel();
  JButton btnOk = new JButton();
  JButton btnCancel = new JButton();

  private uchicago.src.simbuilder.beans.network.LayoutEditor editor;
  private JDialog dialog;
  private LayoutProperty source;
  private IntrospectPanel iPanel;

  public LayoutPropertyPanel(LayoutProperty source) {
    this.source = source;
    try {
      jbInit();
    } catch (Exception e) {
      e.printStackTrace();
    }

    addListeners();
  }

  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.LOWERED, Color.white,
            new Color(142, 142, 142));
    titledBorder1 = new TitledBorder(border1, "Layout Properties");
    border2 = BorderFactory.createCompoundBorder(titledBorder1,
            BorderFactory.
            createEmptyBorder(2, 2, 2, 2));
    this.setLayout(borderLayout1);
    ctrPanel.setLayout(borderLayout2);
    ctrPanel.setBorder(border2);
    btnOk.setMnemonic('O');
    btnOk.setText("OK");
    btnCancel.setMnemonic('C');
    btnCancel.setText("Cancel");
    this.add(ctrPanel, BorderLayout.CENTER);
    this.add(btnPanel, BorderLayout.SOUTH);
    btnPanel.add(btnOk, null);
    btnPanel.add(btnCancel, null);
    iPanel = new IntrospectPanel(source, source.getProperties(), true, false);
    ctrPanel.add(iPanel, BorderLayout.CENTER);
  }


  private void addListeners() {
    btnOk.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) dialog.dispose();
        editor.setValue(source);
        editor.firePropertyChange();
      }
    });

    btnCancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (dialog != null) dialog.dispose();
      }
    });
  }

  public void display(JFrame f, LayoutEditor editor) {
    this.editor = editor;
    dialog = new JDialog(f, false);
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.getContentPane().add(this, BorderLayout.CENTER);
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        dialog.dispose();
      }
    });

    dialog.pack();
    //dialog.setSize(350, 350);
    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }
}


