package uchicago.src.simbuilder.beans.network;

import uchicago.src.sim.analysis.NetSequenceSetupPanel;
import uchicago.src.simbuilder.property.EvolverPropertyEditor;

import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

public class NetStatsPropertyEditor extends EvolverPropertyEditor {

  private JButton b = EvolverPropertyEditor.getEditButton();
  private JLabel label = EvolverPropertyEditor.getLabel();
  private NetStats stats;

  public NetStatsPropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    b.setToolTipText("Edit Network Stats to Plot");
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(b);
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(label);

    b.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        showDialog();
      }
    });
  }

  public void setValue(Object val) {
    stats = new NetStats((NetStats) val);
    String lblText = stats.toBePlotted();
    label.setText(stats.toBePlotted());
    label.setToolTipText(lblText);
  }

  public Object getValue() {
    return new uchicago.src.simbuilder.beans.network.NetStats(stats);
  }

  public void showDialog() {

    final JDialog dialog = new JDialog((JFrame) panel.getTopLevelAncestor(),
            true);
    dialog.getContentPane().setLayout(new BorderLayout());
    dialog.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent evt) {
        dialog.dispose();
      }
    });

    JPanel p = new JPanel(new BorderLayout());
    p.add(new NetSequenceSetupPanel(stats.getRows()), BorderLayout.CENTER);
    JPanel buttons = new JPanel();
    JButton ok = new JButton("OK");
    JButton cancel = new JButton("Cancel");

    cancel.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        dialog.dispose();
      }
    });

    ok.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
        setValue(stats);
        firePropertyChange();
        dialog.dispose();
      }
    });

    buttons.add(ok);
    buttons.add(cancel);
    p.add(buttons, BorderLayout.SOUTH);
    dialog.getContentPane().add(p, BorderLayout.CENTER);
    dialog.pack();
    dialog.setSize(452, 190);
    uchicago.src.guiUtils.GuiUtilities.centerComponentOnScreen(dialog);
    dialog.setVisible(true);
  }

  public void setPropertyFromValue(Object bean) {
    NetworkPlotProducer plot = (NetworkPlotProducer) bean;
    plot.setStatsToPlot((NetStats) getValue());
  }
}
