package uchicago.src.simbuilder.beans.network;

import uchicago.src.simbuilder.EvolverController;
import uchicago.src.simbuilder.beans.EvolverBeanInfo;
import uchicago.src.simbuilder.beans.ModelProducerBeanInfo;

import javax.swing.*;
import java.awt.*;
import java.beans.BeanDescriptor;

/**
 * BeanInfo for the NetworkModelProducer.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:28 $
 */

public class NetworkModelProducerBeanInfo extends EvolverBeanInfo implements ModelProducerBeanInfo {

  public static String IMAGE = "/uchicago/src/simbuilder/images/FlowGraph.gif";
  private static final String[][] props = {{"Actions", "actions"},
                                           {"Display Name", "displayName"},
                                           {"Master Schedule", "masterSchedule"},
                                           {"Model Name", "modelName"},
                                           {"Fields", "parameters"},
                                           {"Schedule", "schedule"}};

  public NetworkModelProducerBeanInfo() {
    super(uchicago.src.simbuilder.beans.network.NetworkModelProducer.class, props);
  }


  public BeanDescriptor getBeanDescriptor() {
    BeanDescriptor bd = new BeanDescriptor(beanClass);
    bd.setDisplayName("Default Network Model");
    return bd;
  }


  public Image getIcon(int iconKind) {
    return new ImageIcon(getClass().getResource(IMAGE)).getImage();
  }

  public void loadModelProducer(EvolverController controller, boolean loadModel) {
    controller.loadPalette("Network");
    if (loadModel) controller.addBeanToTree("Network", "uchicago.src.simbuilder.beans.network.NetworkModelProducer", 0);
  }
}
