package uchicago.src.simbuilder.property;

import javax.swing.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.*;

/**
 * Property editor for boolean types. This is a near copy of the similar
 * class in the Swing beanbox demo. Displays boolean state as a checkbox.
 *
 * @author Nick Collier
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:50 $
 */

public class BooleanPropertyEditor extends EvolverPropertyEditor {

  private JCheckBox box = new JCheckBox();
  private boolean state = true;

  public BooleanPropertyEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.add(box);
    box.setBackground(Color.WHITE);
    box.setFont(box.getFont().deriveFont(Font.BOLD));

    box.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        setValue(new Boolean(!state));
      }
    });
  }

  public void setValue(Object val) {
    super.setValue(val);
    Boolean b = (Boolean) val;
    state = b.booleanValue();
    box.setSelected(b.booleanValue());
    box.setText(b.toString());
  }
}
