package uchicago.src.simbuilder.property;

import javax.swing.*;
import java.awt.*;
import java.beans.PropertyEditorSupport;

/**
 * Base editor class for editing properties in the simbuilder property panel.
 * For primitives and Strings these are mostly copies of the property editors
 * used by the Swing based beanbox demo.
 *
 * @author Nick Collier
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:50 $
 */

public abstract class EvolverPropertyEditor extends PropertyEditorSupport {

  // subclasses must instantiate and place "editor" components on
  // this panel
  protected JPanel panel;


  public Component getCustomEditor() {
    return panel;
  }

  public boolean supportCustomEditor() {
    return true;
  }
  
  /**
   * Sets the bean's property from the current value in the editor. 
   * 
   * @param bean
   */ 
  public void setPropertyFromValue(Object bean) {}
  
  public static JButton getEditButton() {
    JButton button = new JButton("Edit");
    button.setMaximumSize(new Dimension(button.getMaximumSize().width, 18));
    return button;
  }
  
  public static JLabel getLabel() {
    JLabel label = new JLabel();
    label.setFont(label.getFont().deriveFont(Font.BOLD));
    return label;
  }
}
