package uchicago.src.simbuilder.property;

import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.PlainDocument;

/**
 * Document that only accepts integers. Used to ensure that
 * the TextField used to edit the String representation of an int or
 * Integer only accepts integers.
 * <p/>
 * $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:50 $
 */

public class LongDocument extends PlainDocument {

  public void insertString(int offs, String string, AttributeSet att)
          throws BadLocationException {
    try {
      Long.parseLong(string);
    } catch (NumberFormatException ex) {
      return;
    }

    super.insertString(offs, string, att);
  }
}



