package uchicago.src.simbuilder.property;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

/**
 * Property editor for Strings. This is a near copy of the similar
 * class in the Swing beanbox demo.
 *
 * @author Nick Collier
 * @version $Revision: 1.1.1.1 $ $Date: 2004/09/30 03:40:50 $
 */

public class StringPropertyEditor extends TextFieldEditor {


  /*
   * The constructor for an EvolverPropertyEditor should perform
   * whatever gui creation / layout is appropriate. In this case
   * a JTextField is created and that JTextField is added to the
   * panel. panel is a protected ivar in EvolverPropertyEditor. All
   * the gui components used by an editor should be added to this panel.
   */
  public StringPropertyEditor() {
    field.addActionListener(new ActionListener() {
      public void actionPerformed(ActionEvent e) {
        if (isEmpty())
          field.setText(superGetValue().toString());
        else
          setValue(field.getText());
      }
    });
  }

  protected Object getObjectFromField() {
    return field.getText();
  }

  /**
   * Called when the editor is created. That is, the bean is introspected
   * for each String property in the bean an editor is created, and
   * setValue is called for each editor passing the value of the
   * String property.
   */
  public void setValue(Object val) {
    super.setValue(val);
    if (val != null) {
      field.setText(val.toString());
    } else {
      field.setText("");
    }
  }
}
