package uchicago.src.simbuilder.property;

import javax.swing.*;
import java.awt.*;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;

public abstract class TextFieldEditor extends EvolverPropertyEditor {

  protected JTextField field = new JTextField();

  public TextFieldEditor() {
    panel = new JPanel();
    panel.setBackground(Color.WHITE);
    panel.setLayout(new BoxLayout(panel, BoxLayout.X_AXIS));
    panel.add(Box.createRigidArea(new Dimension(5, 0)));
    panel.add(field);
    field.setFont(field.getFont().deriveFont(Font.BOLD));


    field.addFocusListener(new FocusAdapter() {
      public void focusLost(FocusEvent evt) {
        if (isEmpty()) {
          TextFieldEditor.super.setValue(null);
        } else {
          //TextFieldEditor.super.setValue(getObjectFromField());
          getValue();
        }
      }
    });

  }

  protected boolean isEmpty() {
    return field.getText().trim().length() == 0;
  }

  public Object getValue() {
    if (isEmpty()) {
      throw new
              IllegalArgumentException("Invalid value; empty values not allowed");
    }

    Object fieldVal = getObjectFromField();
    Object storedVal = super.getValue();
    if (!fieldVal.equals(storedVal)) super.setValue(fieldVal);
    return super.getValue();
  }

  protected Object superGetValue() {
    return super.getValue();
  }

  public void setValue(Object val) {
    super.setValue(val);
    if (val != null) {
      field.setText(val.toString());
    }
    // could set field to 0 if val is null?
  }

  protected abstract Object getObjectFromField();
}
